; Xe[WT

EN_ST5_CHAPTER		.equ	0
EN_ST5_SPARK_A		.equ	1
EN_ST5_AGGFAIRY_A	.equ	2
EN_ST5_AGGFAIRY_B	.equ	3
EN_ST5_AGGFAIRY_C	.equ	4
EN_ST5_LILY_A		.equ	5
EN_ST5_LILY_B		.equ	6

EN_ST5_PRISM_A		.equ	8
EN_ST5_PRISM_B		.equ	9
EN_ST5_PRISM_C1		.equ	10
EN_ST5_PRISM_C2		.equ	11
EN_ST5_PRISM_D1		.equ	12
EN_ST5_PRISM_D2		.equ	13
EN_ST5_PRISM_E1		.equ	14
EN_ST5_PRISM_E2		.equ	15
EN_ST5_PRISM_F1		.equ	16
EN_ST5_PRISM_F2		.equ	17
EN_ST5_PRISM_G1		.equ	18
EN_ST5_PRISM_G2		.equ	19
EN_ST5_PRISM_H		.equ	20
EN_ST5_PRISM_I		.equ	21
EN_ST5_INSTRUMENT_C	.equ	22
EN_ST5_GENERATOR_H	.equ	23

EN_LILY_INVCNT		.equ	(EVS_D)
EN_ST5_ANGLE		.equ	(EN_REG)	; 4bytes
EN_ST5_ANGLE2		.equ	(EN_ST5_ANGLE+3)
EN_ST5_BANK		.equ	(EN_REG+4)	; 2bytes
EN_ST5_PHASE		.equ	(EN_REG+6)
EN_ST5_PHASE2		.equ	(EVS_D)
EN_ST5_INVPAL		.equ	(EVS_D)
EN_ST5_FADE		.equ	(EN_REG+7)

EN_ST5_LASER		.equ	(EN_WORK+0)	; 4*12byte
EN_ST5_SYNC		.equ	(EN_WORK+84)	; 3bytes
EN_ST5_DIR		.equ	(EN_WORK+87)	; 3bytes

ST5_PASSAGE_TIME	.equ	$04c0

; Enter/Leave Flag
ELF_ST5_CENTER		.equ	$00
ELF_ST5_LEFT		.equ	$01
ELF_ST5_UPPER		.equ	$02
ELF_ST5_RIGHT		.equ	$03
ELF_ST5_TOP_LEFT	.equ	$00
ELF_ST5_TOP_CENTER	.equ	$04
ELF_ST5_TOP_RIGHT	.equ	$08
ELF_ST5_LUNASA		.equ	$10
ELF_ST5_MERLIN		.equ	$20
ELF_ST5_LYRICA		.equ	$30

ST5_ENBOSS_WAITSYNC	.macro
			lda	#(\1)
			jsr	St5_EnBoss_WaitSync
			.endm

ST5_ENBOSS_WAITSYNC2	.macro
			lda	#(\1)
			ldy	#((.base\@)-(\2)+2)
			.base\@:
			jsr	St5_EnBoss_WaitSync2
			.endm


St5_Data:

; V[PX

St5_EventSeq:
	EV_BANK2	BANK_CHR_ENEMY+2
	EV_BANK3	BANK_CHR_CHAPT+1
	EV_BGM		10
	EV_SET		EVS_SPEED, BSW_2F_M
	EV_SET		EVS_E, 0

;	EV_JMP		St5_EventSeqBoss1
;	EV_JMP		St5_EventSeqNext1
;	EV_JMP		St5_EventSeqNext2
;	EV_JMP		St5_EventSeqBoss2
	EV_WAIT		20

	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$10
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$10
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$10
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$10
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$10

	EV_WAIT		20

	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$10
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$10
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$10
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$10
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$10

	EV_WAIT		15

	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_32 & 15)+$10
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_32 & 15)+$10
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_32 & 15)+$10
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_32 & 15)+$10
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_32 & 15)+$10

	EV_WAIT		15

	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_48 & 15)+$10
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_48 & 15)+$10
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_48 & 15)+$10
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_48 & 15)+$10
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_48 & 15)+$10

	EV_WAIT		10

	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_48 & 15)+$10
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_32 & 15)+$10
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_48 & 15)+$10
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_32 & 15)+$10
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_48 & 15)+$10
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_32 & 15)+$10
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_48 & 15)+$10
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_32 & 15)+$10
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_48 & 15)+$10
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_32 & 15)+$10

	EV_WAIT		15

	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_32 & 15)+$10
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_48 & 15)+$10
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_32 & 15)+$10
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_48 & 15)+$10
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_32 & 15)+$10
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_48 & 15)+$10
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_32 & 15)+$10
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_48 & 15)+$10
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_32 & 15)+$10
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_48 & 15)+$10

	EV_WAIT		15

	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_32 & 15)+$20
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$20
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_32 & 15)+$20
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$20
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_32 & 15)+$20
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$20
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_32 & 15)+$20
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$20
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_32 & 15)+$20
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$20

	EV_WAIT		15

	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$20
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_32 & 15)+$20
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$20
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_32 & 15)+$20
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$20
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_32 & 15)+$20
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$20
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_32 & 15)+$20
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$20
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_32 & 15)+$20
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$20
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_32 & 15)+$20
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$20
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_32 & 15)+$20

	EV_WAIT		30
	EV_ENEMY	EN_ST5_CHAPTER,0
	EV_WAIT		50

	EV_BANK3	BANK_CHR_BOSS+5
	EV_PAL		COL_FAIRY_LILAC

	EV_CALL0	St5_EventSeqEnemy1
	EV_CALL0	St5_EventSeqEnemy1

	EV_CALL0	St5_EventSeqEnemy2

	EV_WAIT		20

	EV_CALL0	St5_EventSeqEnemy2

	EV_WAIT		24

	EV_CALL0	St5_EventSeqEnemy3
	EV_CALL0	St5_EventSeqEnemy3

	EV_CALL0	St5_EventSeqEnemy4
	EV_CALL0	St5_EventSeqEnemy4

	EV_CALL0	St5_EventSeqEnemy5
	EV_CALL0	St5_EventSeqEnemy5

	EV_CALL0	St5_EventSeqEnemy6

	EV_WAIT		16

	EV_CALL0	St5_EventSeqEnemy6

	EV_WAIT		20
St5_EventSeqBoss1:
	EV_SET		EVS_E, 1
	EV_BANK3	BANK_CHR_BOSS+5
	EV_PAL		COL_LILY
	EV_SETUP	SSF_MODE_BOSS|SSF_ERASE_ENEMY|SSF_RESOLVE_BONUS
	EV_ENEMY	EN_ST5_LILY_A, POS_64_2
	EV_WAIT_SEM

	EV_SETUP	SSF_MODE_NORMAL|SSF_RESOLVE_BONUS
	EV_WAIT		2
	EV_PAL		COL_FAIRY_LILAC

; oߎԂŃWv
.head1:
	EV_NATIVE	.tail1
	lda	#LOW(ST5_PASSAGE_TIME)
	sec
	sbc	<ST_CNT
	sta	<FNC_WORK
	lda	#HIGH(ST5_PASSAGE_TIME)
	sbc	<ST_CNT+1
	tay
	lda	<FNC_WORK
.1:
	cpy	#0
	bne	.2
	cmp	#(22*8)
	bcc	.3
.2:
	sec
	sbc	#(22*8)
	bcs	.1
	dey
	bcc	.1	; same as jmp
.3:
	cmp	#22
	bcc	.4
	iny
;	sec
	sbc	#22
	bcs	.3
.4:
	tax
	lda	.jmp3,y
;	clc
	adc	.jmp2,x
	sta	<EVS_A
	ldy	.jmp1,x
	rts
.jmp1:
	.db	(.tail1-.head1+15)
	.db	(.tail1-.head1+15)
	.db	(.tail1-.head1+15)
	.db	(.tail1-.head1+15)
	.db	(.tail1-.head1+15)
	.db	(.tail1-.head1+15)
	.db	(.tail1-.head1+15)
	.db	(.tail1-.head1+14)
	.db	(.tail1-.head1+13)
	.db	(.tail1-.head1+12)
	.db	(.tail1-.head1+11)
	.db	(.tail1-.head1+10)
	.db	(.tail1-.head1+ 9)
	.db	(.tail1-.head1+ 8)
	.db	(.tail1-.head1+ 7)
	.db	(.tail1-.head1+ 6)
	.db	(.tail1-.head1+ 5)
	.db	(.tail1-.head1+ 4)
	.db	(.tail1-.head1+ 3)
	.db	(.tail1-.head1+ 2)
	.db	(.tail1-.head1+ 1)
	.db	(.tail1-.head1+ 0)
.jmp2:
	.db	18,15,12, 9, 6, 3
	.db	 0, 0, 0, 0, 0, 0, 0, 0
	.db	 0, 0, 0, 0, 0, 0, 0, 0
.jmp3:
	.db	(St5_EventSeqSkip8-.head2)
	.db	(St5_EventSeqSkip7-.head2)
	.db	(St5_EventSeqSkip6-.head2)
	.db	(St5_EventSeqSkip5-.head2)
	.db	(St5_EventSeqSkip4-.head2)
	.db	(St5_EventSeqSkip3-.head2)
	.db	(St5_EventSeqSkip2-.head2)
	.db	(St5_EventSeqSkip1-.head2)
.tail1:
	EV_WAIT		1
	EV_WAIT		1
	EV_WAIT		1
	EV_WAIT		1
	EV_WAIT		1
	EV_WAIT		1
	EV_WAIT		1
	EV_WAIT		1
	EV_WAIT		1
	EV_WAIT		1
	EV_WAIT		1
	EV_WAIT		1
	EV_WAIT		1
	EV_WAIT		1
	EV_WAIT		1
.head2:
	EV_NATIVE	.tail2
	ldy	<EVS_A
	rts
.tail2:

St5_EventSeqLoop1:
	EV_WAIT		16
	EV_SET		EVS_E, 0

St5_EventSeqSkip1:
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$f0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$f0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$f0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$f0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$f0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$f0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$f0

	EV_WAIT		16
	EV_SET		EVS_E, 0

St5_EventSeqSkip2:
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$e0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$e0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$e0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$e0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$e0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$e0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$e0

	EV_WAIT		16
	EV_SET		EVS_E, 0

St5_EventSeqSkip3:
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$a0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$a0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$a0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$a0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$a0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$a0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$a0

	EV_WAIT		16
	EV_SET		EVS_E, 0

St5_EventSeqSkip4:
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$a0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$a0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$a0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$a0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$a0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$a0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$a0

	EV_WAIT		16
	EV_SET		EVS_E, 0

St5_EventSeqSkip5:
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$e0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$e0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$e0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$e0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$e0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$e0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$e0

	EV_WAIT		16
	EV_SET		EVS_E, 0

St5_EventSeqSkip6:
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$e0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$e0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$e0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$e0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$e0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$e0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$e0

	EV_WAIT		16
	EV_SET		EVS_E, 0

St5_EventSeqSkip7:
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$b0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$b0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$b0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$b0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$b0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$b0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$b0

	EV_WAIT		16
	EV_SET		EVS_E, 0

St5_EventSeqSkip8:
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$b0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$b0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$b0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$b0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$b0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$b0
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$b0

	EV_NATIVE	.tail
	lda	<ST_CNT+1
	cmp	#HIGH(ST5_PASSAGE_TIME)
	bne	.1
	lda	<ST_CNT
	cmp	#LOW(ST5_PASSAGE_TIME)
.1:
	bcc	.2
	iny
	iny
.2:
	rts
.tail:
	EV_JMP		St5_EventSeqLoop1

	EV_SET		EVS_E, 0
	EV_WAIT		30

	EV_ENEMY	EN_ST5_AGGFAIRY_B,POS_48_2+$80
	EV_WAIT		12
	EV_ENEMY	EN_ST5_AGGFAIRY_B,POS_80_2+$80
	EV_WAIT		12
	EV_ENEMY	EN_ST5_AGGFAIRY_B,POS_32_2+$80
	EV_WAIT		12
	EV_ENEMY	EN_ST5_AGGFAIRY_B,POS_96_2+$80
	EV_WAIT		8
	EV_ENEMY	EN_ST5_AGGFAIRY_B,POS_64_2+$80
	EV_WAIT		8
	EV_ENEMY	EN_ST5_AGGFAIRY_B,POS_64_2+$c0
	EV_WAIT		6
	EV_ENEMY	EN_ST5_AGGFAIRY_B,POS_48_2+$c0
	EV_WAIT		6
	EV_ENEMY	EN_ST5_AGGFAIRY_B,POS_80_2+$c0
	EV_WAIT		6
	EV_ENEMY	EN_ST5_AGGFAIRY_B,POS_40_2+$80
	EV_WAIT		6
	EV_ENEMY	EN_ST5_AGGFAIRY_B,POS_88_2+$80
	EV_WAIT		6
	EV_ENEMY	EN_ST5_AGGFAIRY_B,POS_64_2+$80
	EV_WAIT		6
	EV_ENEMY	EN_ST5_AGGFAIRY_B,POS_64_2+$c0
	EV_WAIT		6
	EV_ENEMY	EN_ST5_AGGFAIRY_B,POS_24_2+$80
	EV_ENEMY	EN_ST5_AGGFAIRY_B,POS_104_2+$80

St5_EventSeqNext1:

	EV_CALL0	St5_EventSeqEnemy7
	EV_CALL0	St5_EventSeqEnemy7

	EV_CALL0	St5_EventSeqEnemy8

	EV_WAIT		12

	EV_CALL0	St5_EventSeqEnemy8

;	EV_WAIT		12
	EV_WAIT		8

St5_EventSeqNext2:
	EV_BANK3	BANK_CHR_BOSS+5
	EV_PAL		COL_LILY
	EV_WAIT		20
	EV_ENEMY	EN_ST5_LILY_B, POS_64_2
	EV_WAIT		60
	EV_WAIT		30
	EV_SETUP	SSF_MODE_NORMAL|SSF_RESOLVE_BONUS
	EV_WAIT		30

St5_EventSeqBoss2:
;	EV_JMP		.next
	EV_NATIVE	.tail1
	lda	#LOW(St5_LandSeq17)
	sta	BGS_SEQ1
	lda	#HIGH(St5_LandSeq17)
	sta	BGS_SEQ1+1
	lda	#PS_BG_MAP5+3
	sta	BGS_PAL1
	rts
.tail1;
	EV_TALK		1
	EV_BANK3	BANK_CHR_BOSS+6
	EV_PAL		COL_PRISM
	EV_ENEMY	EN_ST5_PRISM_A, ELF_ST5_LUNASA|ELF_ST5_LEFT|ELF_ST5_TOP_LEFT
	EV_ENEMY	EN_ST5_PRISM_A, ELF_ST5_MERLIN|ELF_ST5_RIGHT|ELF_ST5_TOP_RIGHT
	EV_ENEMY	EN_ST5_PRISM_A, ELF_ST5_LYRICA|ELF_ST5_UPPER|ELF_ST5_TOP_CENTER
	EV_WAIT_SEM

	EV_WAIT		4

	EV_TALK		2
	EV_BANK3	BANK_CHR_BOSS+6
	EV_PAL		COL_PRISM

	EV_SET		EVS_F, 0

.head2:
	EV_NATIVE	.tail2
	lda	<PL_T
	and	#$fe
	clc
	adc	#(.tail2-.head2)
	tay
	rts
.tail2
	EV_JMP		St5_EventSeqBoss3
	EV_JMP		St5_EventSeqBoss4
	EV_JMP		St5_EventSeqBoss5

St5_EventSeqBoss3:
	EV_SETUP	SSF_MODE_BOSS|SSF_ERASE_ENEMY|SSF_RESOLVE_BONUS
	EV_NEXT_STEP	0, EN_ST5_PRISM_C2
	EV_NEXT_STEP	1, EN_ST5_PRISM_B
	EV_NEXT_STEP	2, EN_ST5_PRISM_B
	EV_WAIT_SEM

	EV_SETUP	SSF_MODE_NORMAL|SSF_RESOLVE_BONUS
	EV_WAIT		4

	EV_SETUP	SSF_MODE_BOSS|SSF_ERASE_ENEMY|SSF_RESOLVE_BONUS
	EV_NEXT_STEP	0, EN_ST5_PRISM_B
	EV_ENEMY	EN_ST5_PRISM_D1, POS_104_2
	EV_WAIT_SEM

	EV_SETUP	SSF_MODE_NORMAL|SSF_RESOLVE_BONUS
	EV_WAIT		4

	EV_CHG_EFF	0
	EV_SETUP	SSF_MODE_BOSS|SSF_BG_EFFECT|SSF_ERASE_ENEMY|SSF_RESOLVE_BONUS
	EV_ENEMY	EN_ST5_PRISM_F1, ELF_ST5_LUNASA|ELF_ST5_LEFT|ELF_ST5_TOP_LEFT
	EV_NEXT_STEP	1, EN_ST5_PRISM_F2
	EV_ENEMY	EN_ST5_PRISM_F1, ELF_ST5_LYRICA|ELF_ST5_RIGHT|ELF_ST5_TOP_RIGHT
	EV_WAIT_SEM

	EV_SETUP	SSF_MODE_NORMAL|SSF_RESOLVE_BONUS
	EV_WAIT		4

	EV_SETUP	SSF_MODE_BOSS|SSF_ERASE_ENEMY|SSF_RESOLVE_BONUS
	EV_NEXT_STEP	0, EN_ST5_PRISM_B
	EV_NEXT_STEP	1, EN_ST5_PRISM_B
	EV_NEXT_STEP	2, EN_ST5_PRISM_E2
	EV_WAIT_SEM

	EV_SETUP	SSF_MODE_NORMAL|SSF_RESOLVE_BONUS
	EV_WAIT		4

	EV_CHG_EFF	3
	EV_SETUP	SSF_MODE_BOSS|SSF_BG_EFFECT|SSF_ERASE_ENEMY|SSF_RESOLVE_BONUS
	EV_ENEMY	EN_ST5_PRISM_G1, ELF_ST5_LUNASA|ELF_ST5_LEFT|ELF_ST5_TOP_LEFT
	EV_ENEMY	EN_ST5_PRISM_G1, ELF_ST5_MERLIN|ELF_ST5_RIGHT|ELF_ST5_TOP_RIGHT
	EV_NEXT_STEP	2, EN_ST5_PRISM_G2
	EV_WAIT_SEM
	EV_CLR_LAYER3

	EV_JMP		St5_EventSeqBoss6

St5_EventSeqBoss4:
	EV_SETUP	SSF_MODE_BOSS|SSF_ERASE_ENEMY|SSF_RESOLVE_BONUS
	EV_NEXT_STEP	0, EN_ST5_PRISM_B
	EV_NEXT_STEP	1, EN_ST5_PRISM_B
	EV_NEXT_STEP	2, EN_ST5_PRISM_E2
	EV_WAIT_SEM

	EV_SETUP	SSF_MODE_NORMAL|SSF_RESOLVE_BONUS
	EV_WAIT		4

	EV_SETUP	SSF_MODE_BOSS|SSF_ERASE_ENEMY|SSF_RESOLVE_BONUS
	EV_NEXT_STEP	2, EN_ST5_PRISM_B
	EV_ENEMY	EN_ST5_PRISM_C1, POS_104_2
	EV_WAIT_SEM

	EV_SETUP	SSF_MODE_NORMAL|SSF_RESOLVE_BONUS
	EV_WAIT		4

	EV_CHG_EFF	0
	EV_SETUP	SSF_MODE_BOSS|SSF_BG_EFFECT|SSF_ERASE_ENEMY|SSF_RESOLVE_BONUS
	EV_NEXT_STEP	0, EN_ST5_PRISM_F2
	EV_ENEMY	EN_ST5_PRISM_F1, ELF_ST5_MERLIN|ELF_ST5_LEFT|ELF_ST5_TOP_LEFT
	EV_ENEMY	EN_ST5_PRISM_F1, ELF_ST5_LYRICA|ELF_ST5_RIGHT|ELF_ST5_TOP_RIGHT
	EV_WAIT_SEM

	EV_SETUP	SSF_MODE_NORMAL|SSF_RESOLVE_BONUS
	EV_WAIT		4

	EV_SETUP	SSF_MODE_BOSS|SSF_ERASE_ENEMY|SSF_RESOLVE_BONUS
	EV_NEXT_STEP	0, EN_ST5_PRISM_B
	EV_NEXT_STEP	1, EN_ST5_PRISM_D2
	EV_NEXT_STEP	2, EN_ST5_PRISM_B
	EV_WAIT_SEM

	EV_SETUP	SSF_MODE_NORMAL|SSF_RESOLVE_BONUS
	EV_WAIT		4

	EV_CHG_EFF	3
	EV_SETUP	SSF_MODE_BOSS|SSF_BG_EFFECT|SSF_ERASE_ENEMY|SSF_RESOLVE_BONUS
	EV_ENEMY	EN_ST5_PRISM_G1, ELF_ST5_LUNASA|ELF_ST5_LEFT|ELF_ST5_TOP_LEFT
	EV_NEXT_STEP	1, EN_ST5_PRISM_G2
	EV_ENEMY	EN_ST5_PRISM_G1, ELF_ST5_LYRICA|ELF_ST5_RIGHT|ELF_ST5_TOP_RIGHT
	EV_WAIT_SEM
	EV_CLR_LAYER3

	EV_JMP		St5_EventSeqBoss6

St5_EventSeqBoss5:
	EV_SETUP	SSF_MODE_BOSS|SSF_ERASE_ENEMY|SSF_RESOLVE_BONUS
	EV_NEXT_STEP	0, EN_ST5_PRISM_B
	EV_NEXT_STEP	1, EN_ST5_PRISM_D2
	EV_NEXT_STEP	2, EN_ST5_PRISM_B
	EV_WAIT_SEM

	EV_SETUP	SSF_MODE_NORMAL|SSF_RESOLVE_BONUS
	EV_WAIT		4

	EV_SETUP	SSF_MODE_BOSS|SSF_ERASE_ENEMY|SSF_RESOLVE_BONUS
	EV_NEXT_STEP	1, EN_ST5_PRISM_B
	EV_ENEMY	EN_ST5_PRISM_E1, POS_104_2
	EV_WAIT_SEM

	EV_SETUP	SSF_MODE_NORMAL|SSF_RESOLVE_BONUS
	EV_WAIT		4

	EV_CHG_EFF	0
	EV_SETUP	SSF_MODE_BOSS|SSF_BG_EFFECT|SSF_ERASE_ENEMY|SSF_RESOLVE_BONUS
	EV_ENEMY	EN_ST5_PRISM_F1, ELF_ST5_LUNASA|ELF_ST5_LEFT|ELF_ST5_TOP_LEFT
	EV_ENEMY	EN_ST5_PRISM_F1, ELF_ST5_MERLIN|ELF_ST5_RIGHT|ELF_ST5_TOP_RIGHT
	EV_NEXT_STEP	2, EN_ST5_PRISM_F2
	EV_WAIT_SEM

	EV_SETUP	SSF_MODE_NORMAL|SSF_RESOLVE_BONUS
	EV_WAIT		4

	EV_SETUP	SSF_MODE_BOSS|SSF_ERASE_ENEMY|SSF_RESOLVE_BONUS
	EV_NEXT_STEP	0, EN_ST5_PRISM_C2
	EV_NEXT_STEP	1, EN_ST5_PRISM_B
	EV_NEXT_STEP	2, EN_ST5_PRISM_B
	EV_WAIT_SEM

	EV_SETUP	SSF_MODE_NORMAL|SSF_RESOLVE_BONUS
	EV_WAIT		4

	EV_CHG_EFF	3
	EV_SETUP	SSF_MODE_BOSS|SSF_BG_EFFECT|SSF_ERASE_ENEMY|SSF_RESOLVE_BONUS
	EV_NEXT_STEP	0, EN_ST5_PRISM_G2
	EV_ENEMY	EN_ST5_PRISM_G1, ELF_ST5_MERLIN|ELF_ST5_LEFT|ELF_ST5_TOP_LEFT
	EV_ENEMY	EN_ST5_PRISM_G1, ELF_ST5_LYRICA|ELF_ST5_RIGHT|ELF_ST5_TOP_RIGHT
	EV_WAIT_SEM
	EV_CLR_LAYER3

St5_EventSeqBoss6:
	EV_SETUP	SSF_MODE_NORMAL|SSF_RESOLVE_BONUS
	EV_WAIT		4

	EV_SET		EVS_F, 0

	EV_CHG_EFF	3
	EV_SETUP	SSF_MODE_BOSS|SSF_BG_EFFECT|SSF_RESOLVE_BONUS
	EV_NEXT_STEP	0, EN_ST5_PRISM_H
	EV_NEXT_STEP	1, EN_ST5_PRISM_H
	EV_NEXT_STEP	2, EN_ST5_PRISM_H
	EV_WAIT_SEM
	EV_CLR_LAYER3

	EV_NEXT_STEP	0, EN_ST5_PRISM_I
	EV_NEXT_STEP	1, EN_ST5_PRISM_I
	EV_NEXT_STEP	2, EN_ST5_PRISM_I

	EV_SETUP	SSF_MODE_NORMAL|SSF_RESOLVE_BONUS
	EV_WAIT		8

	EV_SETUP	SSF_CONVERGE_BORDER
	EV_WAIT		2

	EV_WAIT_LAYER0
	EV_TALK		3
	EV_BANK3	BANK_CHR_BOSS+6
	EV_PAL		COL_PRISM
	EV_END

;.next:
;	EV_BANK3	BANK_CHR_BOSS+6
;	EV_PAL		COL_PRISM
;	EV_ENEMY	EN_ST5_LUNASA_A, POS_64_2
;	EV_ENEMY	EN_ST5_MERLIN_A, POS_64_2
;	EV_ENEMY	EN_ST5_LYRICA_A, POS_64_2
;St5_EventSeqEndless:
;	EV_WAIT		64
;	EV_JMP		St5_EventSeqEndless

St5_EventSeqEnemy1:
	EV_ENEMY	EN_ST5_AGGFAIRY_A,POS_112_2
	EV_WAIT		8

	EV_ENEMY	EN_ST5_AGGFAIRY_A,POS_16_2
	EV_WAIT		8

	EV_ENEMY	EN_ST5_AGGFAIRY_A,POS_40_2
	EV_WAIT		8

	EV_ENEMY	EN_ST5_AGGFAIRY_A,POS_96_2
	EV_WAIT		2

	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$00
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$00
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$00
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$00
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$00

	EV_WAIT		2

	EV_ENEMY	EN_ST5_AGGFAIRY_A,POS_72_2
	EV_WAIT		8

	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$00
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$00
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$00
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$00
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$00

	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$00
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$00
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$00
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$00
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$00

	EV_WAIT		20

	EV_RET0

St5_EventSeqEnemy2:
	EV_ENEMY	EN_ST5_AGGFAIRY_B,POS_16_2
	EV_WAIT		12
	EV_ENEMY	EN_ST5_AGGFAIRY_B,POS_112_2
	EV_WAIT		12
	EV_ENEMY	EN_ST5_AGGFAIRY_B,POS_32_2
	EV_WAIT		8
	EV_ENEMY	EN_ST5_AGGFAIRY_B,POS_96_2
	EV_WAIT		8
	EV_ENEMY	EN_ST5_AGGFAIRY_B,POS_40_2
	EV_WAIT		4
	EV_ENEMY	EN_ST5_AGGFAIRY_B,POS_88_2

	EV_RET0

St5_EventSeqEnemy3:
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$30
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$30
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$30
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$30
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$30
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$30
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$30

	EV_WAIT		16

	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$30
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$30
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$30
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$30
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$30
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$30
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$30

	EV_WAIT		16

	EV_RET0

St5_EventSeqEnemy4:
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$40
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$40
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$40
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$40
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$40
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$40
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$40

	EV_WAIT		16

	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$40
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$40
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$40
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$40
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$40
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$40
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$40

	EV_WAIT		16

	EV_RET0

St5_EventSeqEnemy5:
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$50
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$00
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$50
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$50
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$50
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$00
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$50

	EV_WAIT		16

	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$50
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$00
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$50
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$50
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$50
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$00
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$50

	EV_WAIT		16

	EV_RET0

St5_EventSeqEnemy6:
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$30
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$40
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$50
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$30
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$40
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$50
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$70

	EV_WAIT		16

	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$30
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$40
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$50
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$30
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$40
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$50
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$70

	EV_RET0

St5_EventSeqEnemy7:
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$80

	EV_WAIT		12

	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$80

	EV_WAIT		12

	EV_ENEMY	EN_ST5_AGGFAIRY_C,POS_16_2
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_AGGFAIRY_C,POS_112_2
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$80

	EV_WAIT		12

	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_AGGFAIRY_C,POS_32_2
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_AGGFAIRY_C,POS_96_2
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$80

	EV_WAIT		12

	EV_RET0

St5_EventSeqEnemy8:
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$80

	EV_WAIT		12

	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$80

	EV_WAIT		12

	EV_ENEMY	EN_ST5_AGGFAIRY_C,POS_16_2+$80
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_AGGFAIRY_C,POS_112_2+$80
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_126_40 & 15)+$80

	EV_WAIT		12

	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_AGGFAIRY_C,POS_32_2+$80
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$80
	EV_WAIT		1
	EV_ENEMY	EN_ST5_AGGFAIRY_C,POS_96_2+$80
	EV_ENEMY	EN_ST5_SPARK_A,(POS_2_40 & 15)+$80

	EV_RET0



; G֌W

Enemy_Lily_Update:
	lda	<EN_BOSS_FC
	beq	.1
	dec	<EN_BOSS_FC
	bne	.1
	jsr	.2
.1:
	jmp	Enemy_Boss_Update
.2:
	jmp	[EN_BOSS_CB]

Enemy_Lily_Retire:
	lda	#0
	sta	<EN_BOSS_CB
	sta	<EN_BOSS_CB+1
	sta	<EN_BOSS_FC
	jmp	Enemy_Boss_Retire

Enemy_Prism_Reflect:
	lda	<EN_BOSS_FC
	beq	.1
	dec	<EN_BOSS_FC
	bne	.1
	jsr	.2
.1:
	ldy	#2
	jmp	Enemy_Boss_Reflect_
.2:
	jmp	[EN_BOSS_CB]

Enemy_Prism_Retire:
	lda	#0
	sta	<EN_BOSS_CB
	sta	<EN_BOSS_CB+1
	sta	<EN_BOSS_FC
	jmp	Enemy_Boss_Retire

St5_RetireSpark:
	lda	#0
	sta	EN_P,x
	lda	<EVS_E
	bne	.1
	lda	EN_S,x
	and	#$20
	beq	.1
	jsr	St5_EnSparkShot
.1:
	jmp	Enemy_Normal_Retire

St5_EnSparkShot:
	lda	EN_D,x
	and	#$07
	beq	.2
	cmp	#$03
	bcs	.1
	ldy	EN_A,x
	bpl	.1
	eor	#$08
.1:
	tay
	lda	.blt_hi-1,y
	sta	<FNC_WORK
	lda	.blt_lo-1,y
	ldy	<FNC_WORK
	jmp	SMCL(Shot_Normal_Create)
.2:
	rts
.blt_lo:
	.db	LOW(BL(1,Blt5_SparkA1))
	.db	LOW(BL(1,Blt5_SparkB1))
	.db	LOW(BL(1,Blt5_SparkC))
	.db	LOW(BL(1,Blt5_SparkD))
	.db	LOW(BL(1,Blt5_SparkE))
	.db	LOW(BL(1,Blt5_SparkF))
	.db	LOW(BL(1,Blt5_SparkG))
	.db	0
	.db	LOW(BL(1,Blt5_SparkA2))
	.db	LOW(BL(1,Blt5_SparkB2))
.blt_hi:
	.db	HIGH(BL(1,Blt5_SparkA1))
	.db	HIGH(BL(1,Blt5_SparkB1))
	.db	HIGH(BL(1,Blt5_SparkC))
	.db	HIGH(BL(1,Blt5_SparkD))
	.db	HIGH(BL(1,Blt5_SparkE))
	.db	HIGH(BL(1,Blt5_SparkF))
	.db	HIGH(BL(1,Blt5_SparkG))
	.db	0
	.db	HIGH(BL(1,Blt5_SparkA2))
	.db	HIGH(BL(1,Blt5_SparkB2))

; `F[֐

St5_EnChapter:
	lda	#40
	sta	EN_X,x
	lda	#64
	sta	EN_Y,x
	lda	#$40
	jmp	Enemy_Effect_Create

St5_EnSparkA:
	sta	<FNC_WORK+6
	and	#$0f
	ora	#(POS_2_16 & $f0)
	tay
	jsr	Enemy_SetPosition

	lda	#LOW(.param)
	ldy	#HIGH(.param)
	jsr	Enemy_SetParam

	ldy	<FNC_WORK+6
	lda	Xcn,y
	and	#$08
	ora	EN_S,x
	sta	EN_S,x

	lda	Xcn,y
	and	#$07
	tay
	ora	#$90
	sta	EN_D,x

	lda	#$0f
	cpy	#$07
	beq	.1
	jsr	Rand
	and	#$0f
.1:
	sta	EN_P,x

	lda	EN_X,x
	cmp	#64
	lda	.angle,y
	bcs	.2
	eor	#$ff
;	clc
	adc	#1
.2:
	sta	EN_A,x
	tay
	lda	EN_SP,x
	jsr	Enemy_SetVelocity

	lda	#6
	jsr	Enemy_CB_Wait
.3:
	lda	#2
	jsr	Enemy_CB_Wait

	jsr	.shot
	bcs	.3

	lda	#LOW(.ac_data)
	ldy	#HIGH(.ac_data)
	jsr	Enemy_SetAcceleration
	lda	EN_A,x
	bpl	.4
	lda	#$f0
	sta	EN_IA,x
.4:

	lda	EN_D,x
	ora	#$60
	sta	EN_D,x
.6:
	lda	#2
	jsr	Enemy_CB_Wait

	jsr	.shot
	bcs	.6

	lda	EN_D,x
	and	#$07
	cmp	#$07
	lda	#20
	bcc	.8
	lda	#12
.8:
	jsr	Enemy_CB_Wait

	jsr	Enemy_ClearAcceleration
	jmp	Enemy_ClearCallback
.shot:
	lda	EN_P,x
	beq	.shot1
	dec	EN_P,x
	bne	.shot1
	lda	EN_S,x
	eor	#$20
	sta	EN_S,x
	jsr	St5_EnSparkShot
.shot1:
	lda	EN_D,x
	sec
	sbc	#$10
	sta	EN_D,x
	cmp	#$10
	rts
.param:
	.db	EPF_BASE|EPF_VEL
	.db	$01,$20,$02,$00	; T,S,LIFE,P
	.db	$40,20		; A,SP
.angle:
	.db	$40,$40,$40,$40,$38,$48,$40,$48
.ac_data:
	.db	$02,$00,$10 ; VC,IS,IA

St5_EnAggFairyA:
	tay
	jsr	Enemy_SetPosition
	lda	#LOW(.param)
	ldy	#HIGH(.param)
	jsr	Enemy_SetParam

	lda	#8
	jsr	Enemy_CB_Wait

	lda	#LOW(.ac_data1)
	ldy	#HIGH(.ac_data1)
	jsr	Enemy_SetAcceleration
	lda	EN_X,x
	cmp	#$40
	bcc	.1
	lda	#$fc
	sta	EN_IA,x
.1:

	lda	#8
	sta	EN_D,x
.3:
	lda	EN_A,x
	sta	<FNC_WORK+8
	jsr	Rand
	sta	EN_A,x
	lda	#LOW(BL(1,Blt5_AggFairyA))
	ldy	#HIGH(BL(1,Blt5_AggFairyA))
	jsr	SMCL(Shot_Normal_Create)
	lda	<FNC_WORK+8
	sta	EN_A,x

	lda	#3
	jsr	Enemy_CB_Wait

	dec	EN_D,x
	bne	.3

	lda	#8
	jsr	Enemy_CB_Wait

	lda	#LOW(.ac_data2)
	ldy	#HIGH(.ac_data2)
	jsr	Enemy_SetAcceleration
	jmp	Enemy_ClearCallback
.param:
	.db	EPF_BASE|EPF_VEL|EPF_ACC
	.db	$02,$01,$0c,$00	; T,S,LIFE,P
	.db	$80,20		; A,SP
	.db	$02,$fe,$00	; VC,IS,IA
.ac_data1:
	.db	$02,$00,$04 ; VC,IS,IA
.ac_data2:
	.db	$04,$02,$00 ; VC,IS,IA

St5_EnAggFairyB:
	sta	<FNC_WORK+6
	and	#$3f
	tay
	jsr	Enemy_SetPosition
	lda	#LOW(.param)
	ldy	#HIGH(.param)
	jsr	Enemy_SetParam

	bit	<FNC_WORK+6
	bvc	.1
	lda	#16
	sta	EN_SP,x
.1:

	lda	EN_X,x
	cmp	#64
	lda	EN_S,x
	bcc	.2
	eor	#$03
.2:
	ldy	<FNC_WORK+6
	bpl	.3
	eor	#$10
.3:
	sta	EN_S,x

	lda	#32
	jsr	Enemy_CB_Wait

	lda	#$00
	sta	EN_SP,x
	jsr	Enemy_SetVelocity
	jsr	Enemy_ClearAcceleration

	lda	EN_S,x
	and	#$10
	bne	.4
	jsr	Enemy_GetPlayerAngle
	sta	EN_A,x
.4:

	lda	EN_S,x
	and	#1
	ora	#30
	tay
.5:
	sta	EN_D,x
	lda	.blt_data_hi,y
	sta	<FNC_WORK
	lda	.blt_data_lo,y
	ldy	<FNC_WORK
	jsr	SMCL(Shot_Normal_Create)

	lda	#4
	jsr	Enemy_CB_Wait

	ldy	EN_D,x
	dey
	dey
	tya
	bpl	.5

	lda	#12
	jsr	Enemy_CB_Wait

	lda	#$00
	sta	EN_A,x
	lda	#LOW(.ac_data)
	ldy	#HIGH(.ac_data)
	jsr	Enemy_SetAcceleration
	jmp	Enemy_ClearCallback
.param:
	.db	EPF_BASE|EPF_VEL|EPF_ACC
	.db	$02,$00,$0c,$03	; T,S,LIFE,P
	.db	$80,20		; A,SP
	.db	$04,$fe,$00	; VC,IS,IA
.ac_data:
	.db	$02,$02,$00 ; VC,IS,IA
.blt_data_lo:
	.db	LOW(BL(1,Blt5_AggFairyB16)), LOW(BL(1,Blt5_AggFairyC16))
	.db	LOW(BL(1,Blt5_AggFairyB15)), LOW(BL(1,Blt5_AggFairyC15))
	.db	LOW(BL(1,Blt5_AggFairyB14)), LOW(BL(1,Blt5_AggFairyC14))
	.db	LOW(BL(1,Blt5_AggFairyB13)), LOW(BL(1,Blt5_AggFairyC13))
	.db	LOW(BL(1,Blt5_AggFairyB12)), LOW(BL(1,Blt5_AggFairyC12))
	.db	LOW(BL(1,Blt5_AggFairyB11)), LOW(BL(1,Blt5_AggFairyC11))
	.db	LOW(BL(1,Blt5_AggFairyB10)), LOW(BL(1,Blt5_AggFairyC10))
	.db	LOW(BL(1,Blt5_AggFairyB9)),  LOW(BL(1,Blt5_AggFairyC9))
	.db	LOW(BL(1,Blt5_AggFairyB8)),  LOW(BL(1,Blt5_AggFairyC8))
	.db	LOW(BL(1,Blt5_AggFairyB7)),  LOW(BL(1,Blt5_AggFairyC7))
	.db	LOW(BL(1,Blt5_AggFairyB6)),  LOW(BL(1,Blt5_AggFairyC6))
	.db	LOW(BL(1,Blt5_AggFairyB5)),  LOW(BL(1,Blt5_AggFairyC5))
	.db	LOW(BL(1,Blt5_AggFairyB4)),  LOW(BL(1,Blt5_AggFairyC4))
	.db	LOW(BL(1,Blt5_AggFairyB3)),  LOW(BL(1,Blt5_AggFairyC3))
	.db	LOW(BL(1,Blt5_AggFairyB2)),  LOW(BL(1,Blt5_AggFairyC2))
	.db	LOW(BL(1,Blt5_AggFairyB1)),  LOW(BL(1,Blt5_AggFairyC1))
.blt_data_hi:
	.db	HIGH(BL(1,Blt5_AggFairyB16)),HIGH(BL(1,Blt5_AggFairyC16))
	.db	HIGH(BL(1,Blt5_AggFairyB15)),HIGH(BL(1,Blt5_AggFairyC15))
	.db	HIGH(BL(1,Blt5_AggFairyB14)),HIGH(BL(1,Blt5_AggFairyC14))
	.db	HIGH(BL(1,Blt5_AggFairyB13)),HIGH(BL(1,Blt5_AggFairyC13))
	.db	HIGH(BL(1,Blt5_AggFairyB12)),HIGH(BL(1,Blt5_AggFairyC12))
	.db	HIGH(BL(1,Blt5_AggFairyB11)),HIGH(BL(1,Blt5_AggFairyC11))
	.db	HIGH(BL(1,Blt5_AggFairyB10)),HIGH(BL(1,Blt5_AggFairyC10))
	.db	HIGH(BL(1,Blt5_AggFairyB9)), HIGH(BL(1,Blt5_AggFairyC9))
	.db	HIGH(BL(1,Blt5_AggFairyB8)), HIGH(BL(1,Blt5_AggFairyC8))
	.db	HIGH(BL(1,Blt5_AggFairyB7)), HIGH(BL(1,Blt5_AggFairyC7))
	.db	HIGH(BL(1,Blt5_AggFairyB6)), HIGH(BL(1,Blt5_AggFairyC6))
	.db	HIGH(BL(1,Blt5_AggFairyB5)), HIGH(BL(1,Blt5_AggFairyC5))
	.db	HIGH(BL(1,Blt5_AggFairyB4)), HIGH(BL(1,Blt5_AggFairyC4))
	.db	HIGH(BL(1,Blt5_AggFairyB3)), HIGH(BL(1,Blt5_AggFairyC3))
	.db	HIGH(BL(1,Blt5_AggFairyB2)), HIGH(BL(1,Blt5_AggFairyC2))
	.db	HIGH(BL(1,Blt5_AggFairyB1)), HIGH(BL(1,Blt5_AggFairyC1))

St5_EnAggFairyC:
	cmp	#$80
	and	#$3f
	tay
	lda	#7
	rol	a
	sta	EN_D,x
	jsr	Enemy_SetPosition
	lda	#LOW(.param)
	ldy	#HIGH(.param)
	jsr	Enemy_SetParam

	lda	#32
	jsr	Enemy_CB_Wait

	lda	#$00
	sta	EN_SP,x
	jsr	Enemy_SetVelocity
	jsr	Enemy_ClearAcceleration

.2:
	ldy	EN_D,x
	lda	.blt_data_hi,y
	sta	<FNC_WORK
	lda	.blt_data_lo,y
	ldy	<FNC_WORK
	jsr	SMCL(Shot_Normal_Create)

	lda	#2
	jsr	Enemy_CB_Wait

	dec	EN_D,x
	dec	EN_D,x
	bpl	.2

	lda	#32
	jsr	Enemy_CB_Wait

	lda	#$00
	sta	EN_A,x
	lda	#LOW(.ac_data)
	ldy	#HIGH(.ac_data)
	jsr	Enemy_SetAcceleration
	jmp	Enemy_ClearCallback
.param:
	.db	EPF_BASE|EPF_VEL|EPF_ACC
	.db	$03,$02,$0c,$03	; T,S,LIFE,P
	.db	$80,18		; A,SP
	.db	$04,$fe,$00	; VC,IS,IA
.ac_data:
	.db	$02,$02,$00 ; VC,IS,IA
.blt_data_lo:
	.db	LOW(BL(1,Blt5_AggFairyD8)), LOW(BL(1,Blt5_AggFairyE8))
	.db	LOW(BL(1,Blt5_AggFairyD7)), LOW(BL(1,Blt5_AggFairyE7))
	.db	LOW(BL(1,Blt5_AggFairyD6)), LOW(BL(1,Blt5_AggFairyE6))
	.db	LOW(BL(1,Blt5_AggFairyD5)), LOW(BL(1,Blt5_AggFairyE5))
	.db	LOW(BL(1,Blt5_AggFairyD4)), LOW(BL(1,Blt5_AggFairyE4))
	.db	LOW(BL(1,Blt5_AggFairyD3)), LOW(BL(1,Blt5_AggFairyE3))
	.db	LOW(BL(1,Blt5_AggFairyD2)), LOW(BL(1,Blt5_AggFairyE2))
	.db	LOW(BL(1,Blt5_AggFairyD1)), LOW(BL(1,Blt5_AggFairyE1))
.blt_data_hi:
	.db	HIGH(BL(1,Blt5_AggFairyD8)),HIGH(BL(1,Blt5_AggFairyE8))
	.db	HIGH(BL(1,Blt5_AggFairyD7)),HIGH(BL(1,Blt5_AggFairyE7))
	.db	HIGH(BL(1,Blt5_AggFairyD6)),HIGH(BL(1,Blt5_AggFairyE6))
	.db	HIGH(BL(1,Blt5_AggFairyD5)),HIGH(BL(1,Blt5_AggFairyE5))
	.db	HIGH(BL(1,Blt5_AggFairyD4)),HIGH(BL(1,Blt5_AggFairyE4))
	.db	HIGH(BL(1,Blt5_AggFairyD3)),HIGH(BL(1,Blt5_AggFairyE3))
	.db	HIGH(BL(1,Blt5_AggFairyD2)),HIGH(BL(1,Blt5_AggFairyE2))
	.db	HIGH(BL(1,Blt5_AggFairyD1)),HIGH(BL(1,Blt5_AggFairyE1))

St5_EnLilyA:
	tay
	jsr	Enemy_SetPosition

	lda	#LOW(.param)
	ldy	#HIGH(.param)
	jsr	Enemy_SetParam

	lda	#1
	sta	<EVS_SEM
	sta	<EVS_SPELL
	lda	#34
	sta	<EN_TIME

	lda	#LOW(St5_EnLilyA_CB)
	sta	<EN_BOSS_CB
	lda	#HIGH(St5_EnLilyA_CB)
	sta	<EN_BOSS_CB+1

	; [vC
	lda	<PL_X
	ldy	#64
	jsr	.warp_in

	; Sʒe
;	lda	EN_S,x
;	and	#$b1
;	ora	#$08
;	sta	EN_S,x
	jsr	.style_stand

	lda	#12
	jsr	Enemy_CB_Wait

	jsr	.shot1

	; [vAEg
	jsr	.warp_out

	lda	#3
	sta	<EVS_A
.next1:
	lda	#3
	sta	<EVS_B
.next2:
	; [vC
	lda	<PL_X
	ldy	#64
	jsr	.warp_in

	; Sʒe
;	lda	EN_S,x
;	and	#$b1
;	ora	#$08
;	sta	EN_S,x
	jsr	.style_stand

	jsr	.shot1

	; [vAEg
	jsr	.warp_out

	dec	<EVS_B
	bne	.next2

.next3:
	; [vC
	lda	#64
	ldy	#96
	jsr	.warp_in

	; ړ
	lda	EN_S,x
	and	#$b1
	ora	#$0a
	sta	EN_S,x

	lda	#14
	ldy	#$00
	jsr	Enemy_SetVelocity

	lda	#8
	jsr	Enemy_CB_Wait

	; e
;	lda	EN_S,x
;	and	#$b1
;	ora	#$08
;	sta	EN_S,x
	jsr	.style_stand

	lda	#$6a
	sta	<EVS_C
	lda	#$4b
	sta	<EVS_B
	clc
.next4:
	lda	#$80	; sec̏ȗ̂$80ݒ
	rol	a
	sta	<FNC_WORK+8
	tay

	lda	#$00
;	sec
	sbc	<EVS_C
	sta	EN_A,x
	lda	.blt_hi+2,y
	sta	<FNC_WORK
	lda	.blt_lo+2,y
	ldy	<FNC_WORK
	jsr	SMCL(Shot_Normal_Create)

	lda	<EVS_C
	sta	EN_A,x
	clc
	adc	#$06
	sta	<EVS_C
	ldy	<FNC_WORK+8
	lda	.blt_hi,y
	sta	<FNC_WORK
	lda	.blt_lo,y
	ldy	<FNC_WORK
	jsr	SMCL(Shot_Normal_Create)

	lda	#2
	jsr	Enemy_CB_Wait

	; EVS_B̒l̂悤ɐڂ
	; $4b,$8a,$09,$48,$87,$06,$45,$84,$03,$42,$81,$00
	lda	<EVS_B
	bpl	.5
	eor	#$40
.5:
	clc
	adc	#$3f
	sta	<EVS_B
	bne	.next4

	; ~
	jsr	Enemy_ClearVelocity

	lda	#8
	jsr	Enemy_CB_Wait

	; Sʒe
	jsr	.shot1
	lda	#4
	jsr	Enemy_CB_Wait

	; [vAEg
	jsr	.warp_out

	; ^CAbv
	dec	<EVS_A
	beq	.away
	jmp	.next1
.away:
	; 
	lda	#0
	sta	<EN_BOSS_LIFE
	sta	<EN_BOSS_LIFE+1
	rts
.warp_in:
	sta	EN_X,x
	tya
	sta	EN_Y,x

	lda	#32
	sta	<EN_LILY_INVCNT
	lda	#1
	sta	<EN_BOSS_FC

	lda	#32
	jmp	Enemy_CB_Wait
.warp_out:
	lda	EN_S,x
	and	#$b1
	ora	#$46
	sta	EN_S,x

	lda	#12
	jmp	Enemy_CB_Wait
.shot1:
	jsr	Rand
	sta	EN_A,x

	lda	#LOW(BL(1,Blt5_LilyA))
	ldy	#HIGH(BL(1,Blt5_LilyA))
	jsr	SMCL(Shot_Normal_Create)

	lda	#28
	jmp	Enemy_CB_Wait
.style_stand:
	lda	EN_S,x
	and	#$b1
	ora	#$08
	sta	EN_S,x
	rts
.param:
	.db	EPF_BASE|EPF_VEL|EPF_ACC|EPF_BOSS|EPF_REFLECT
	.db	$44,$40,$7f,(ITEM_1UP<<4)+7	; T,S,LIFE,P
	.db	$80,00		; A,SP
	.db	$00,$00,$00	; VC,IS,IA
	.db	$00		; BOSS_INX
	.dw	$0080		; BOSS_LIFE
	.dw	Enemy_Boss_Reflect
.blt_lo:
	.db	LOW(BL(1,Blt5_LilyB1))
	.db	LOW(BL(1,Blt5_LilyB2))
	.db	LOW(BL(1,Blt5_LilyB3))
	.db	LOW(BL(1,Blt5_LilyB4))
.blt_hi:
	.db	HIGH(BL(1,Blt5_LilyB1))
	.db	HIGH(BL(1,Blt5_LilyB2))
	.db	HIGH(BL(1,Blt5_LilyB3))
	.db	HIGH(BL(1,Blt5_LilyB4))

St5_EnLilyA_CB:
	lda	<EN_LILY_INVCNT
	beq	.1
	dec	<EN_LILY_INVCNT
.1:
	lda	#1
	sta	<EN_BOSS_FC
	rts

St5_EnLilyB:
	tay
	jsr	Enemy_SetPosition

	lda	#LOW(.param)
	ldy	#HIGH(.param)
	jsr	Enemy_SetParam

	lda	#28
	jsr	Enemy_CB_Wait

	lda	#$00
	sta	EN_SP,x
	jsr	Enemy_SetVelocity
	jsr	Enemy_ClearAcceleration

	lda	#0
	sta	<EVS_C
	lda	#$c0
	sta	<EVS_B
	lda	#64
	sta	<EVS_A
.1:
	lda	<EVS_A
	lsr	a
	bcc	.2
	eor	#$1f
.2:
	rol	a
	asl	a
	asl	a
	sta	<FNC_WORK+8

;	lda	<FNC_WORK+8
	clc
	adc	#$c0
	sta	EN_A,x

	lda	#LOW(BL(1,Blt5_LilyC1))
	ldy	#HIGH(BL(1,Blt5_LilyC1))
	jsr	SMCL(Shot_Normal_Create)

	lda	#$40
	sec
	sbc	<FNC_WORK+8
	sta	EN_A,x

	lda	#LOW(BL(1,Blt5_LilyC2))
	ldy	#HIGH(BL(1,Blt5_LilyC2))
	jsr	SMCL(Shot_Normal_Create)

	jsr	.shot
;	lda	#2
;	jsr	Enemy_CB_Wait

	jsr	.shot
;	lda	#2
;	jsr	Enemy_CB_Wait

	dec	<EVS_A
	bpl	.1

	lda	EN_S,x
	ora	#$80
	sta	EN_S,x
	rts
.shot:
	lda	<EVS_C
	cmp	#2
	adc	#1
	and	#3
	sta	<EVS_C
	bne	.7

	lda	<EVS_B
	sta	EN_A,x
	sec
	sbc	#3
	sta	<EVS_B
	lda	#LOW(BL(1,Blt5_LilyC3))
	ldy	#HIGH(BL(1,Blt5_LilyC3))
	jsr	SMCL(Shot_Normal_Create)
.7:
	lda	#2
	jmp	Enemy_CB_Wait
.param:
	.db	EPF_BASE|EPF_VEL|EPF_ACC|EPF_BOSS|EPF_REFLECT
	.db	$04,$08,$7f,(ITEM_BOMB<<4)+7	; T,S,LIFE,P
	.db	$80,18		; A,SP
	.db	$04,$fe,$00	; VC,IS,IA
	.db	$00		; BOSS_INX
	.dw	$00ff		; BOSS_LIFE
	.dw	Enemy_Boss_Reflect
.ac_data:
	.db	$02,$02,$00 ; VC,IS,IA


St5_EnPrismA:
	tay
	cmp	#$20
	bcs	.1

	lda	#1
	sta	<EVS_SEM

	lda	#7
	sta	<EVS_SPELL

	lda	#LOW($00c0)
	sta	<EN_BOSS_LIFE
	lda	#HIGH($00c0)
	sta	<EN_BOSS_LIFE+1

	lda	#LOW(Enemy_Prism_Reflect)
	sta	EN_FNC_REFLECT
	lda	#HIGH(Enemy_Prism_Reflect)
	sta	EN_FNC_REFLECT+1
	lda	#0
	sta	<EN_BOSS_CB
	sta	<EN_BOSS_CB+1
	sta	<EN_BOSS_FC
.1:
	tya
	jsr	St5_EnBoss_InitByFlag

	; o
	lda	EN_D,x
	jsr	St5_EnBoss_SetParam

	lda	EN_X,x
	cmp	#64
	bcs	.3
	lda	EN_S,x
	ora	#$01
	sta	EN_S,x
.3:

	jsr	SMCL(Enemy_CB_SetEntry)
	ldy	EN_D,x
	lda	EN_ST5_DIR,y
	tay
	lda	.ypos,y
	sta	<FNC_WORK
	lda	.xpos,y
	ldy	<FNC_WORK
	jsr	Enemy_CB_Move

;	lda	#$00
;	sta	EN_S,x

	lda	#4
	jsr	Enemy_CB_Wait

	jsr	Enemy_ClearCallback

	lda	EN_D,x
	bne	.5
;	lda	#0
	sta	<EVS_SEM
.5:
	rts
.xpos:
	.db	64, 40, 64, 88
.ypos:
	.db	48, 48, 40, 48

St5_EnPrismB:
	lda	EN_D,x
	jsr	St5_EnBoss_SetParam

	; ޏ
	lda	#0
	ldy	EN_X,x
	cpy	#80
	adc	#0
	cpy	#48
	adc	#0
	tay
	lda	EN_S,x
	and	#$f8
	ora	.style,y
	sta	EN_S,x
	lda	.angle,y
	sta	EN_A,x
	tay
	lda	#21
	sta	EN_SP,x
	jmp	Enemy_SetVelocity
.style:
	.db	$03, $00, $02
.angle:
	.db	$18, $00, $e8

; ʏUP
; iT ʏUP ʂ̎e
St5_EnPrismC1:
	tay
	jsr	Enemy_SetPosition

St5_EnPrismC2:
	lda	#1
	sta	<EVS_SEM
	lda	#49
	sta	<EN_TIME

	lda	#LOW(.param)
	ldy	#HIGH(.param)
;	jsr	Enemy_SetParam
	jsr	St5_EnBoss_SetParam_Solo

	; ړ

	jsr	SMCL(Enemy_CB_SetEntry)
	lda	#64
	ldy	#48
	jsr	Enemy_CB_Move

	; yo
	stx	<FNC_WORK+8
	ldy	#$00
	lda	#EN_ST5_INSTRUMENT_C
	jsr	Enemy_Normal_Create
	ldx	<FNC_WORK+8

	lda	#24
	jsr	Enemy_CB_Wait

	lda	#12
	sta	<EVS_A
.loop1:
	jsr	Rand
	and	#$03
	tay
	lda	.ypos,y
	sta	<EVS_Y
	lda	.xpos,y
	sta	<EVS_X

	jsr	.move_set
	lda	<EVS_X
	ldy	<EVS_Y
	jsr	Enemy_CB_Move

	jsr	.stand_wait

	lda	#64
	jsr	.move_set
	lda	#64
	ldy	#48
	jsr	Enemy_CB_Move

	jsr	.stand_wait

	dec	<EVS_A
	beq	.away
	jmp	.loop1
.away:
	jsr	Enemy_ClearCallback

	lda	#0
	sta	<EVS_SEM

	rts
.move_set:
	cmp	EN_X,x
	lda	EN_S,x
	and	#$b8
	adc	#$02
	eor	#$01
	sta	EN_S,x
	jmp	SMCL(Enemy_CB_SetEntry)
.stand_wait:
	lda	EN_S,x
	and	#$b9
	ora	#$04
	sta	EN_S,x

;	lda	#96
	lda	#48
	jmp	Enemy_CB_Wait
.param:
	.db	EPF_BASE|EPF_ACC|EPF_BOSS
	.db	$45,$40,$7f,(ITEM_NONE<<4)+0	; T,S,LIFE,P
	.db	$00,$00,$00	; VC,IS,IA
	.db	$00		; BOSS_INX
	.dw	$00c0		; BOSS_LIFE
.xpos:
	.db	40,48,72,80
.ypos:
	.db	40,32,32,40

St5_EnInstrumentC:
	lda	#LOW(.param)
	ldy	#HIGH(.param)
	jsr	Enemy_SetParam

	lda	#72
	sta	EN_X,x
	lda	#44
	sta	EN_Y,x
	lda	#0
	sta	EN_U,x
	sta	EN_V,x
	jsr	Enemy_ClearVelocity

	lda	#4
	sta	<EVS_C
	lda	<EVS_SPELL
	sta	EN_D,x
.1:
	jsr	.pos
;	ldy	<EN_BOSS_INX
;	lda	EN_Y,y
;	sta	<EVS_V
;	lda	EN_X,y
	clc
	adc	#32
	cmp	#120
	bcc	.2
	lda	#120
.2:
	sta	<EVS_U

	jsr	SMCL(Enemy_CB_SetEntry)
;	lda	<EVS_U
;	ldy	<EVS_V
;	jsr	Enemy_CB_Move
	jsr	.move

	jsr	.shot

	jsr	.wait

	jsr	.pos
;	ldy	<EN_BOSS_INX
;	lda	EN_Y,y
;	sta	<EVS_V
;	lda	EN_X,y
	sec
	sbc	#32
	cmp	#8
	bcs	.4
	lda	#8
.4:
	sta	<EVS_U

	jsr	SMCL(Enemy_CB_SetEntry)
;	lda	<EVS_U
;	ldy	<EVS_V
;	jsr	Enemy_CB_Move
	jsr	.move

	jsr	.shot

	jsr	.wait

	lda	EN_D,x
	cmp	<EVS_SPELL
	beq	.1

	sec
	ror	EN_X,x
	rts
.pos:
	ldy	<EN_BOSS_INX
	lda	EN_Y,y
	sta	<EVS_V
	lda	EN_X,y
	rts
.shot:
	lda	EN_X,x
	sta	<FNC_ARG
	lda	EN_Y,x
	sta	<FNC_ARG+1
	ldy	<EN_BOSS_INX
	lda	EN_X,y
	clc
	adc	<PL_X
	lsr	a
	sta	<FNC_ARG+2
	lda	EN_Y,y
	clc
	adc	<PL_Y
	lsr	a
	sta	<FNC_ARG+3
	jsr	Util_GetAngle
	sta	EN_A,x

	lda	#LOW(BL(1,Blt5_PrismA1))
	ldy	#HIGH(BL(1,Blt5_PrismA1))
	jmp	SMCL(Shot_Normal_Create)
.wait:
	ldy	<EVS_C
	beq	.w1
	dec	<EVS_C
.w1:
	lda	.wait_num,y
	jmp	Enemy_CB_Wait
.move:
	lda	<EVS_U
	ldy	<EVS_V
	jmp	Enemy_CB_Move
.param:
	.db	EPF_BASE
	.db	$08,$40,$7f,(ITEM_NONE<<4)+0	; T,S,LIFE,P
.wait_num:
	.db	48,54,60,66,72

; ʏUQ
;  ʏUP ւɂ背[U[
St5_EnPrismD1:
	tay
	jsr	Enemy_SetPosition

St5_EnPrismD2:
	lda	#1
	sta	<EVS_SEM
	lda	#60
	sta	<EN_TIME

	lda	#LOW(.param)
	ldy	#HIGH(.param)
;	jsr	Enemy_SetParam
	jsr	St5_EnBoss_SetParam_Solo

	; ړ

	jsr	SMCL(Enemy_CB_SetEntry)
	lda	#64
	ldy	#32
	jsr	Enemy_CB_Move

	lda	#8
	jsr	Enemy_CB_Wait

	lda	#12
	sta	<EVS_A
.loop1:
	; ҂
	lda	EN_S,x
	and	#$b9
	ora	#$04
	sta	EN_S,x

	lda	#32
	jsr	Enemy_CB_Wait

	; ւɂ背[U[
	lda	#LOW(BL(1,Blt5_PrismB1))
	ldy	#HIGH(BL(1,Blt5_PrismB1))
	jsr	SMCL(Shot_Normal_Create)

	; ҂
	lda	#16
	jsr	Enemy_CB_Wait

	; e(P{)ړ
;	lda	#LOW(BL(1,Blt5_PrismD1))
;	ldy	#HIGH(BL(1,Blt5_PrismD1))
;	jsr	SMCL(Shot_Normal_Create)
	jsr	.shot1

	jsr	.dest
	sta	<EVS_X

	cpy	#$80
	lda	#$01
	rol	a
	eor	#$01
	sta	EN_S,x

	jsr	SMCL(Enemy_CB_SetEntry)
	lda	<EVS_X
	ldy	#32
	jsr	Enemy_CB_Move

	; e(R{)Sʒe
	lda	#LOW(BL(1,Blt5_PrismD2))
	ldy	#HIGH(BL(1,Blt5_PrismD2))
	jsr	SMCL(Shot_Normal_Create)

	lda	EN_S,x
	eor	#$06
	sta	EN_S,x

	; ҂
	lda	#16
	jsr	Enemy_CB_Wait

	; ւɂ背[U[
	lda	#LOW(BL(1,Blt5_PrismB2))
	ldy	#HIGH(BL(1,Blt5_PrismB2))
	jsr	SMCL(Shot_Normal_Create)

	; ҂
	lda	#32
	jsr	Enemy_CB_Wait

	; Sʒe

	; ҂
	lda	#16
	jsr	Enemy_CB_Wait

	; ړ
	jsr	.dest
	sta	<EVS_X
	sty	<EVS_Y

	cpy	#$80
	lda	#$01
	rol	a
	eor	#$01
	sta	EN_S,x

	jsr	SMCL(Enemy_CB_SetEntry)
	jsr	.dest2
	ldy	#32
	jsr	Enemy_CB_Move

	; e(P{)
;	lda	#LOW(BL(1,Blt5_PrismD1))
;	ldy	#HIGH(BL(1,Blt5_PrismD1))
;	jsr	SMCL(Shot_Normal_Create)
	jsr	.shot1

	; ړ
	lda	<EVS_Y
	cmp	#$80
	ror	a
	sta	<EVS_Y

	jsr	SMCL(Enemy_CB_SetEntry)
	jsr	.dest2
	ldy	#32
	jsr	Enemy_CB_Move

	; e(P{)
;	lda	#LOW(BL(1,Blt5_PrismD1))
;	ldy	#HIGH(BL(1,Blt5_PrismD1))
;	jsr	SMCL(Shot_Normal_Create)
	jsr	.shot1

	; ړ
	jsr	SMCL(Enemy_CB_SetEntry)
	lda	<EVS_X
	ldy	#32
	jsr	Enemy_CB_Move

	; e(P{)
;	lda	#LOW(BL(1,Blt5_PrismD1))
;	ldy	#HIGH(BL(1,Blt5_PrismD1))
;	jsr	SMCL(Shot_Normal_Create)
	jsr	.shot1

	dec	<EVS_A
	beq	.away
	jmp	.loop1
.away:
	jsr	Enemy_ClearCallback

	lda	#0
	sta	<EVS_SEM

	rts
.dest:
	lda	EN_X,x
	cmp	<PL_X
	bcs	.12
;	clc
	adc	#24
	cmp	#128-8
	bcc	.11
	lda	#128-8
.11:
	ldy	#$f0
	rts
.12:
;	sec
	sbc	#24
	bmi	.13
	cmp	#8
	bcs	.14
.13:
	lda	#8
.14:
	ldy	#$10
	rts
.dest2:
	lda	<EVS_X
	clc
	adc	<EVS_Y
	cmp	#192
	bcs	.21
	cmp	#128-8
	bcs	.22
	cmp	#8
	bcs	.23
.21:
	lda	$8
	rts
.22:
	lda	#128-8
.23:
	rts
.shot1:
	lda	#LOW(BL(1,Blt5_PrismD1))
	ldy	#HIGH(BL(1,Blt5_PrismD1))
	jmp	SMCL(Shot_Normal_Create)
.param:
	.db	EPF_BASE|EPF_ACC|EPF_BOSS
	.db	$86,$40,$7f,(ITEM_NONE<<4)+0	; T,S,LIFE,P
	.db	$00,$00,$00	; VC,IS,IA
	.db	$01		; BOSS_INX
	.dw	$00c0		; BOSS_LIFE

; ʏUR
; J ʏUR
St5_EnPrismE1:
	tay
	jsr	Enemy_SetPosition

St5_EnPrismE2:
	lda	#1
	sta	<EVS_SEM
	lda	#53
	sta	<EN_TIME

	lda	#LOW(.param)
	ldy	#HIGH(.param)
;	jsr	Enemy_SetParam
	jsr	St5_EnBoss_SetParam_Solo

	; ړ

	jsr	SMCL(Enemy_CB_SetEntry)
	lda	#64
	ldy	#32
	jsr	Enemy_CB_Move

	lda	#8
	jsr	Enemy_CB_Wait

	lda	#$51
	sta	<EVS_B
	lda	#48
	sta	<EVS_A
.loop1:
	lda	EN_S,x
	and	#$b9
	sta	EN_S,x

	; e
	lda	<EVS_B
	cmp	#$80
	rol	<EVS_B
	lda	#LOW(BL(1,Blt5_PrismE1))
	ldy	#HIGH(BL(1,Blt5_PrismE1))
	bcc	.1
	lda	#LOW(BL(1,Blt5_PrismF))
	ldy	#HIGH(BL(1,Blt5_PrismF))
.1:
	jsr	SMCL(Shot_Normal_Create)

	lda	#12
	jsr	Enemy_CB_Wait

	; ړ
	lda	EN_X,x
	cmp	<PL_X
	bcs	.3
	cmp	#128-16
	bcs	.4
.2:
	clc
	adc	#16
	ldy	#$02
	bne	.5	; same as jmp
.3:
	cmp	#16+16
	bcc	.2
.4:
	sec
	sbc	#16
	ldy	#$03
.5:
	sta	<EVS_X

	lda	EN_S,x
	and	#$f8
	ora	Int,y
	sta	EN_S,x

	jsr	SMCL(Enemy_CB_SetEntry)
	lda	<EVS_X
	ldy	#32
	jsr	Enemy_CB_Move

	lda	#8
	jsr	Enemy_CB_Wait

	dec	<EVS_A
	beq	.away
	jmp	.loop1
.away:
	jsr	Enemy_ClearCallback

	lda	#0
	sta	<EVS_SEM

	rts
.param:
	.db	EPF_BASE|EPF_ACC|EPF_BOSS
	.db	$c7,$40,$7f,(ITEM_NONE<<4)+0	; T,S,LIFE,P
	.db	$00,$00,$00	; VC,IS,IA
	.db	$02		; BOSS_INX
	.dw	$00c0		; BOSS_LIFE

; t@gfBjO
St5_EnPrismF1:
	jsr	St5_EnBoss_InitByFlag
	jsr	St5_EnBoss_InitSync

	; o

	lda	EN_D,x
	jsr	St5_EnBoss_SetParam

	jsr	SMCL(Enemy_CB_SetEntry)
	ldy	EN_D,x
	lda	EN_ST5_DIR,y
	tay
	lda	.xpos,y
	ldy	#32
	jsr	Enemy_CB_Move

	; 
	ST5_ENBOSS_WAITSYNC	1

	lda	EN_S,x
	and	#$b9
	ora	#$0c
	sta	EN_S,x

	ldy	EN_D,x
	lda	#$00
	sta	EN_ST5_ANGLE,y
.loop1:
	ldy	EN_D,x
	lda	EN_ST5_ANGLE,y
	clc
	adc	#1
	and	#$07
	sta	EN_ST5_ANGLE,y

	bit	Int+$03
	bne	.skip3
	and	#$04
	bne	.skip1

	lda	#LOW(BL(1,Blt5_PrismH1))
	ldy	#HIGH(BL(1,Blt5_PrismH1))
	bne	.skip2	; same as jmp
.skip1:
	lda	#LOW(BL(1,Blt5_PrismH2))
	ldy	#HIGH(BL(1,Blt5_PrismH2))
.skip2:
	jsr	SMCL(Shot_Normal_Create)

.skip3:
	lda	#12
	jsr	Enemy_CB_Wait

	lda	<EVS_A
	beq	.away
	jmp	.loop1
.away:
	lda	#8
	jsr	Enemy_CB_Wait

	jmp	Enemy_ClearCallback
.xpos:
	.db	64, 40, 64, 88

St5_EnPrismF2:
	lda	#1
	sta	<EVS_SEM
	lda	#35
	sta	<EN_TIME

	lda	#LOW($00c0)
	sta	<EN_BOSS_LIFE
	lda	#HIGH($00c0)
	sta	<EN_BOSS_LIFE+1

	jsr	St5_EnBoss_InitSync

	lda	EN_D,x
	jsr	St5_EnBoss_SetParam
	lda	#(ITEM_1UP<<4)+7
	sta	EN_P,x

	; ړ

	jsr	SMCL(Enemy_CB_SetEntry)
	lda	#64
	ldy	#40
	jsr	Enemy_CB_Move

	; 
	ST5_ENBOSS_WAITSYNC	1

	lda	EN_S,x
	and	#$b9
	ora	#$0c
	sta	EN_S,x

	lda	#8
	sta	<EVS_A
.loop1:
	lda	#4
	sta	<EVS_B
.loop2:
	jsr	Enemy_GetPlayerAngle
	sta	<EN_ST5_PHASE
	lda	#9-1
	sta	<EVS_C
.loop3:
	lda	<EVS_B
	lsr	a
	bcs	.skip3
	ldy	<EVS_C
	bpl	.skip4	; same as jmp
.skip3:
	lda	#9-1
;	sec
	sbc	<EVS_C
	tay
.skip4:
	lda	<EN_ST5_PHASE
	clc
	adc	.angle,y
	sta	EN_A,x

	ldy	<EVS_B
	lda	.blt_hi-1,y
	sta	<FNC_WORK
	lda	.blt_lo-1,y
	ldy	<FNC_WORK
	jsr	SMCL(Shot_Normal_Create)

	lda	#2
	jsr	Enemy_CB_Wait

	dec	<EVS_C
	bpl	.loop3

	lda	#8
	jsr	Enemy_CB_Wait

	dec	<EVS_B
	bne	.loop2

	lda	#32
	jsr	Enemy_CB_Wait

	dec	<EVS_A
	beq	.away
	jmp	.loop1
.away:
	lda	#8
	jsr	Enemy_CB_Wait

	jsr	Enemy_ClearCallback

	lda	#0
	sta	<EN_BOSS_CB
	sta	<EN_BOSS_CB+1
	sta	<EN_BOSS_FC
	sta	<EVS_SEM

	rts
.angle:
	.db	$e0,$e8,$f0,$f8,$00
	.db	$08,$10,$18,$20
.blt_lo:
	.db	LOW(BL(1,Blt5_PrismG4))
	.db	LOW(BL(1,Blt5_PrismG3))
	.db	LOW(BL(1,Blt5_PrismG2))
	.db	LOW(BL(1,Blt5_PrismG1))
.blt_hi:
	.db	HIGH(BL(1,Blt5_PrismG4))
	.db	HIGH(BL(1,Blt5_PrismG3))
	.db	HIGH(BL(1,Blt5_PrismG2))
	.db	HIGH(BL(1,Blt5_PrismG1))

; vYR`Fg
St5_EnPrismG1:
	jsr	St5_EnBoss_InitByFlag
	jmp	_St5_EnPrismG2

St5_EnPrismG2:
	lda	#1
	sta	<EVS_SEM
	lda	#51
	sta	<EN_TIME

	lda	#LOW($00c0)
	sta	<EN_BOSS_LIFE
	lda	#HIGH($00c0)
	sta	<EN_BOSS_LIFE+1

_St5_EnPrismG2:
	jsr	St5_EnBoss_InitSync

	lda	EN_D,x
	jsr	St5_EnBoss_SetParam

	; ړ
	ldy	EN_D,x
	lda	#63
	cmp	.xpos,y
	lda	#$24
	rol	a	; $48 ro $49
	sta	EN_S,x

	jsr	SMCL(Enemy_CB_SetEntry)
	ldy	EN_D,x
	lda	.ypos,y
	sta	<FNC_WORK
	lda	.xpos,y
	ldy	<FNC_WORK
	jsr	Enemy_CB_Move

	; 
	ST5_ENBOSS_WAITSYNC	1

	ldy	EN_D,x
	beq	St5_EnPrismG3
	jmp	St5_EnPrismG4
.xpos:
	.db	64, 24, 104
.ypos:
	.db	32, 48, 48

St5_EnPrismG3:
	; iT
	lda	#(ITEM_BOMB<<4)+7
	sta	EN_P,x

	lda	#$0c
	sta	EN_S,x

	; BGݒ

	stx	<FNC_WORK+8

	lda	#0
	sta	<EVS_C
	sta	<EN_ST5_PHASE2
	lda	#LOW(St5_EnPrismG_CB)
	sta	<EN_BOSS_CB
	lda	#HIGH(St5_EnPrismG_CB)
	sta	<EN_BOSS_CB+1
	lda	#3
	sta	<EN_BOSS_FC

	ldx	#BANK_CHR_SPELL+12
	lda	#LOW(St5_BgDrawPrismA)
	ldy	#HIGH(St5_BgDrawPrismA)
	jsr	St5_EnBoss_SetupBG

	ldx	<FNC_WORK+8

	lda	#3
	sta	<EVS_A
.loop1:
	lda	#$40
	sta	<EN_ST5_ANGLE

	lda	#1
	jsr	Enemy_CB_Wait

	; 
	ST5_ENBOSS_WAITSYNC	2

	; tF[hC
.loop3:
	lda	#4
	jsr	Enemy_CB_Wait

	jsr	St5_EnBoss_FadeIn
	bcs	.loop3

	; 
	ST5_ENBOSS_WAITSYNC	3

	; tF[hAEg
.loop4:
	lda	#4
	jsr	Enemy_CB_Wait

	jsr	St5_EnBoss_FadeOut
	bcc	.loop4

	; 
	ST5_ENBOSS_WAITSYNC	4

	lda	#1
	jsr	Enemy_CB_Wait

	; 
	ST5_ENBOSS_WAITSYNC	5

	; tF[hC
	lda	#$e0
	sta	<EN_ST5_ANGLE
.loop6:
	lda	#4
	jsr	Enemy_CB_Wait

	jsr	St5_EnBoss_FadeIn
	bcs	.loop6

	; ]
.sync6:
	lda	<USR_CNT
	and	#$0e
	bne	.angle6
	lda	<EN_ST5_ANGLE
	sec
	sbc	#2
	sta	<EN_ST5_ANGLE
.angle6:

	ST5_ENBOSS_WAITSYNC2	6, .sync6

	; tF[hAEg
.loop7:
	lda	#4
	jsr	Enemy_CB_Wait

	jsr	St5_EnBoss_FadeOut
	bcc	.loop7

	; 
	ST5_ENBOSS_WAITSYNC	7

	lda	#1
	jsr	Enemy_CB_Wait

	; 
	ST5_ENBOSS_WAITSYNC	8

	; tF[hC
	lda	#$80
	sta	<EN_ST5_ANGLE
.loop9:
	lda	#4
	jsr	Enemy_CB_Wait

	jsr	St5_EnBoss_FadeIn
	bcs	.loop9

	; 
	ST5_ENBOSS_WAITSYNC	9

	lda	#1
	jsr	Enemy_CB_Wait

	; ]
.sync10:
	lda	<EN_ST5_ANGLE
	clc
	adc	#3
	sta	<EN_ST5_ANGLE

	ST5_ENBOSS_WAITSYNC2	10, .sync10

	; tF[hAEg
.loop11:
	lda	#4
	jsr	Enemy_CB_Wait

	jsr	St5_EnBoss_FadeOut
	bcc	.loop11

	; 
	ST5_ENBOSS_WAITSYNC	11

	lda	#32
	jsr	Enemy_CB_Wait

	dec	<EVS_A
	beq	.away
	jmp	.loop1
.away:
	lda	#8
	jsr	Enemy_CB_Wait

	jsr	Enemy_ClearCallback

	lda	#0
	sta	<EN_BOSS_CB
	sta	<EN_BOSS_CB+1
	sta	<EN_BOSS_FC
	sta	<EVS_SEM

	rts

St5_EnPrismG4:
	;  J

.loop1:
	; 
	lda	EN_S,x
	and	#$b9
	sta	EN_S,x

	lda	#8
	jsr	Enemy_CB_Wait

	; ړ
	ldy	EN_D,x
	lda	#63
	cmp	.xpos1-1,y
	lda	#$06
	rol	a	; $0a ro $0b
	sta	EN_S,x

	jsr	SMCL(Enemy_CB_SetEntry)
	ldy	EN_D,x
	lda	.xpos1-1,y
	ldy	#128
	jsr	Enemy_CB_Move

	; 
	ST5_ENBOSS_WAITSYNC	2

	; 
	lda	EN_S,x
	and	#$f9
	ora	#$04
	sta	EN_S,x

	lda	#90
	jsr	Enemy_CB_Wait

	; 
	ST5_ENBOSS_WAITSYNC	3

	lda	#1
	jsr	Enemy_CB_Wait

	; 
	ST5_ENBOSS_WAITSYNC	4

	; ړ
	ldy	EN_D,x
	lda	#63
	cmp	.xpos2-1,y
	lda	#$05
	rol	a	; $0a ro $0b
	sta	EN_S,x

	jsr	SMCL(Enemy_CB_SetEntry)
	ldy	EN_D,x
	lda	.xpos2-1,y
	ldy	#112
	jsr	Enemy_CB_Move

	; 
	ST5_ENBOSS_WAITSYNC	5

	; 
	lda	EN_S,x
	and	#$f9
	ora	#$04
	sta	EN_S,x

	lda	#20
	jsr	Enemy_CB_Wait

	lda	EN_X,x
	cmp	#64
	lda	#$80
	sta	EN_A,x
	lda	#LOW(BL(1,Blt5_PrismJ))
	ldy	#HIGH(BL(1,Blt5_PrismJ))
	jsr	SMCL(Shot_Normal_Create)

	lda	#130
	jsr	Enemy_CB_Wait

	; 
	ST5_ENBOSS_WAITSYNC	6

	lda	#1
	jsr	Enemy_CB_Wait

	; 
	ST5_ENBOSS_WAITSYNC	7

	; ړ
	jsr	SMCL(Enemy_CB_SetEntry)
	lda	EN_X,x
	ldy	#96
	jsr	Enemy_CB_Move

	; 
	ST5_ENBOSS_WAITSYNC	8

	; 
	ldy	EN_D,x
	lda	#63
	cmp	.xpos1-1,y
	lda	#$05
	rol	a	; $0a ro $0b
	sta	EN_S,x

	lda	#1
	jsr	Enemy_CB_Wait

	; 
	ST5_ENBOSS_WAITSYNC	9

	; ړ
	jsr	SMCL(Enemy_CB_SetEntry)
	ldy	EN_D,x
	lda	.xpos1-1,y
	ldy	#56
	jsr	Enemy_CB_SlowMove

	; 
	ST5_ENBOSS_WAITSYNC	10

	lda	#1
	jsr	Enemy_CB_Wait

	; 
	ST5_ENBOSS_WAITSYNC	11

	lda	#20
	jsr	Enemy_CB_Wait

	lda	EN_X,x
	cmp	#64
	lda	#$80
	sta	EN_A,x
	lda	#LOW(BL(1,Blt5_PrismJ))
	ldy	#HIGH(BL(1,Blt5_PrismJ))
	jsr	SMCL(Shot_Normal_Create)

	lda	#12
	jsr	Enemy_CB_Wait

	lda	<EVS_A
	beq	.away
	jmp	.loop1
.away:
	lda	#8
	jsr	Enemy_CB_Wait

	jsr	Enemy_ClearCallback
	rts
.xpos1:
	.db	104, 24
.xpos2:
	.db	24, 104

St5_EnPrismG_CB:
	; e

	ldx	<EN_BOSS_INX

	lda	<EVS_C
	eor	#$01
	sta	<EVS_C
	beq	.1
	lda	#LOW(BL(1,Blt5_PrismI1))
	ldy	#HIGH(BL(1,Blt5_PrismI1))
	bne	.2	; same as jmp
.1:
	lda	#LOW(BL(1,Blt5_PrismI2))
	ldy	#HIGH(BL(1,Blt5_PrismI2))
.2:
	jsr	SMCL(Shot_Normal_Create)

	lda	#32
	sta	<EN_BOSS_FC
	rts


; ԃR`FgOb\
St5_EnPrismH:
	jsr	St5_EnBoss_InitSync

	lda	EN_D,x
	bne	.1
	ldy	#1
	sty	<EVS_SEM
	ldy	#40
	sty	<EN_TIME

	ldy	#LOW($00c0)
	sty	<EN_BOSS_LIFE
	ldy	#HIGH($00c0)
	sty	<EN_BOSS_LIFE+1
.1:
	jsr	St5_EnBoss_SetParam

	; ړ

	jsr	SMCL(Enemy_CB_SetEntry)
	ldy	EN_D,x
	lda	.ypos,y
	sta	<FNC_WORK
	lda	.xpos,y
	ldy	<FNC_WORK
	jsr	Enemy_CB_Move

	; 
	ST5_ENBOSS_WAITSYNC	1

	lda	EN_S,x
	and	#$b9
	ora	#$0a
	sta	EN_S,x

	; BGݒ

	lda	EN_D,x
	bne	.4
	stx	<FNC_WORK+8

	ldy	#$00
	lda	#EN_ST5_GENERATOR_H
	jsr	Enemy_Normal_Create

	ldx	#BANK_CHR_SPELL+16
	lda	#LOW(St5_BgDrawPrismB)
	ldy	#HIGH(St5_BgDrawPrismB)
	jsr	St5_EnBoss_SetupBG

	ldx	<FNC_WORK+8
.4:

	; ]

	ldy	EN_D,x
	lda	.angle,y
	sta	EN_A,x
	tay
	lda	#12
	sta	EN_SP,x
	jsr	Enemy_SetVelocity

	lda	#$a0
	sta	<EVS_A
	lda	#$02
	sta	<EVS_B
.next1:
	lda	#3
	jsr	Enemy_CB_Wait

	lda	EN_A,x
	clc
	adc	#$f8
	sta	EN_A,x
	tay

	eor	#$80
	asl	a
	rol	a
	eor	EN_S,x
	and	#$01
	eor	EN_S,x
	sta	EN_S,x

	lda	EN_SP,x
	jsr	Enemy_SetVelocity

	lda	EN_D,x
	bne	.cnt1

	lda	<EN_ST5_ANGLE
	clc
	adc	#$f8
	sta	<EN_ST5_ANGLE

	dec	<EVS_A
	bne	.cnt1
	dec	<EVS_B
.cnt1
	; ^CAbv
	lda	<EVS_B
	ora	<EVS_A
	bne	.next1
.away:
	jsr	Enemy_ClearVelocity
	jsr	Enemy_ClearAcceleration
	jsr	Enemy_ClearCallback

	; 
	ST5_ENBOSS_WAITSYNC	2

	; 
	lda	EN_D,x
	bne	.away1
	lda	#0
	sta	<EN_BOSS_LIFE
	sta	<EN_BOSS_LIFE+1
.away1:
	rts
.xpos:
	.db	64-25, 64+25, 64+0
.ypos:
	.db	48+15, 48+15, 48-30
.angle:
	.db	$15, $6a, $c0

St5_EnGeneratorH:
	lda	#LOW(.param)
	ldy	#HIGH(.param)
	jsr	Enemy_SetParam

	lda	#0
	sta	<EVS_C
	sta	<EN_ST5_ANGLE2

	lda	#24
	sta	<EN_ST5_INVPAL
	lda	#$52
	sta	<EN_ST5_FADE

	lda	#64
	sta	EN_X,x
	lda	#48
	sta	EN_Y,x
	lda	<EVS_SPELL
	sta	EN_D,x
.1:
	ldy	<EVS_C
	lda	.round,y
	sta	<EVS_C
	lda	.shot,y
	cmp	#2
	bcs	.2
	cmp	#1
	bcs	.3

	; Qe
	lda	<EN_ST5_ANGLE2
	sta	EN_A,x
	clc
	adc	#12
	sta	<EN_ST5_ANGLE2

	lda	#LOW(BL(1,Blt5_PrismK1))
	ldy	#HIGH(BL(1,Blt5_PrismK1))
	bne	.4	; sam as jmp
.2:
	; C(̂)
	lda	#SE_EN_SHOT1
	cmp	<SND_SE
	bcc	.5
	sta	<SND_SE
	bcs	.5	; same as jmp
.3:
	; ˒e
	jsr	Enemy_GetPlayerAngle
	sta	<FNC_WORK
	jsr	Rand
	and	#15
	eor	<FNC_WORK
	sta	EN_A,x

	lda	#LOW(BL(1,Blt5_PrismK2))
	ldy	#HIGH(BL(1,Blt5_PrismK2))
.4:
	jsr	SMCL(Shot_Normal_Create)
.5:

	ldy	<EN_ST5_INVPAL
	beq	.7
	dec	<EN_ST5_INVPAL
	cpy	#6
	bcs	.7

	jsr	St5_EnBoss_FadeIn
.7:

	lda	#3
	jsr	Enemy_CB_Wait

	lda	EN_D,x
	cmp	<EVS_SPELL
	beq	.1

	sec
	ror	EN_X,x
	rts
.param:
	.db	EPF_BASE
	.db	$0b,$40,$7f,(ITEM_NONE<<4)+0	; T,S,LIFE,P
.round:
	.db	1,2,3,0
.shot:
	.db	0,1,0,2

St5_EnPrismI:
	lda	EN_S,x
	and	#$01
	ora	#$40
	sta	EN_S,x
	rts

St5_EnBoss_SetParam:
	asl	a
	asl	a
	asl	a
	adc	#LOW(.param1)
	ldy	#HIGH(.param1)
	bcc	.2
	iny
.2:
	jmp	Enemy_SetParam
.param1:
	; Lunasa
	.db	EPF_BASE|EPF_ACC
	.db	$45,$40,$7f,(ITEM_NONE<<4)+0	; T,S,LIFE,P
	.db	$00,$00,$00	; VC,IS,IA
.param2:
	; Merlin
	.db	EPF_BASE|EPF_ACC
	.db	$86,$40,$7f,(ITEM_NONE<<4)+0	; T,S,LIFE,P
	.db	$00,$00,$00	; VC,IS,IA
.param3:
	; Lirica
	.db	EPF_BASE|EPF_ACC
	.db	$c7,$40,$7f,(ITEM_NONE<<4)+0	; T,S,LIFE,P
	.db	$00,$00,$00	; VC,IS,IA

St5_EnBoss_SetParam_Solo:
	jsr	Enemy_SetParam
	ldy	#8
	lda	[FNC_WORK+2],y
	sta	EN_D,x
	rts

St5_EnBoss_InitSync:
	lda	EN_T,x
	and	#$c0
	asl	a
	rol	a
	rol	a
;	clc
	adc	#$ff
	sta	EN_D,x
	tay
	lda	#0
	sta	EN_ST5_SYNC,y
	rts

St5_EnBoss_WaitSync:
	ldy	#4
St5_EnBoss_WaitSync2:
	sty	<FNC_WORK
	ldy	EN_D,x
	sta	EN_ST5_SYNC,y
	cmp	EN_ST5_SYNC
	bne	.1
	cmp	EN_ST5_SYNC+1
	bne	.1
	cmp	EN_ST5_SYNC+2
	bne	.1
	rts
.1:
	lda	#1
	sta	EN_FC,x
	sec
	pla
	sbc	<FNC_WORK
	sta	EN_CB,x
	pla
	sbc	#0
	sta	EN_CB+1,x
	rts

St5_EnBoss_InitByFlag:
	sta	<FNC_WORK

	; ʒu
	and	#$0c
	lsr	a
	lsr	a
	tay
	lda	.xpos,y
	cmp	#64
	sta	EN_X,x
	lda	#2
	sta	EN_Y,x
	lda	#0
	sta	EN_U,x
	sta	EN_V,x

	; Lݒ
	ldy	<FNC_WORK
	lda	Xcn-16,y
	and	#$03
	sta	EN_D,x
	tay
	stx	<EN_BOSS_INX,y
	lda	.type,y
	sta	EN_T,x
	lda	#$40
	sta	EN_S,x
	lda	#(ITEM_NONE<<4)+0
	sta	EN_P,x

	lda	<FNC_WORK
	and	#$03
	sta	EN_ST5_DIR,y

	rts
.xpos:
	.db	8, 64, 120
.type:
	.db	$45, $86, $c7

St5_EnBoss_SetupBG:
	stx	BGS_BANK3

	ldx	#$00
	stx	<EN_ST5_PHASE
	ldx	#$40
	stx	<EN_ST5_ANGLE
	ldx	#$52
	stx	<EN_ST5_FADE

	ldx	#PS_BG_EFFECT_PR+1
	stx	BGS_PAL3
	ldx	#$55
	stx	BGS_ATTR3
	ldx	#$02
	stx	BGS_CNT3
	ldx	#(BGS_CNT3-BGS_CNT3)
	jsr	BGSeq_SetLayerCB
	ldx	#RLF_SET_LAYER3
	jmp	BGSeq_ReqSetHighLayer

St5_EnBoss_FadeIn:
	lda	<BGC_REF+1
	ora	#(BGF_PALETTE)
	sta	<BGC_REF+1
	lda	<EN_ST5_FADE
	sec
	sbc	#$10
	sta	<EN_ST5_FADE
	sta	<BGC_PAL
	cmp	#$12
	rts

St5_EnBoss_FadeOut:
	lda	<BGC_REF+1
	ora	#(BGF_PALETTE)
	sta	<BGC_REF+1
	lda	<EN_ST5_FADE
	clc
	adc	#$10
	sta	<EN_ST5_FADE
	sta	<BGC_PAL
	cmp	#$52
	rts


; eۊ֌W

St5_ShCbSparkC:
	lda	SH_SP,x
	lsr	a
	sta	SH_SP,x
	ldy	SH_A,x
	jmp	Shot_SetVelocity

St5_ShCbSparkE:
	lda	#$00
	sta	SH_IS,x
	sta	SH_SP,x
	jsr	Shot_SetVelocity

	; ҂
	lda	#4
	jsr	Shot_CB_Wait

	jsr	Shot_GetPlayerAngle
	sta	<FNC_WORK
	lda	SH_T,x
	and	#$30
	beq	.1

	tay
	lda	SH_NUM
	clc
	adc	SH_NUM+1
	cmp	#60
	bcs	.2

	lda	Xcn,y
	tay
;	clc
	adc	.angle-1,y
.1:
	clc
	adc	<FNC_WORK
	sta	SH_A,x
	tay
	lda	#$14
	sta	SH_SP,x
	jmp	Shot_SetVelocity
.2:
;	sec
	ror	SH_X,x
	rts
.angle:
	.db	$55,$aa

St5_ShCbAggFairyA:
	lda	#$00
	sta	SH_IS,x
	sta	SH_SP,x
	jsr	Shot_SetVelocity

	; ҂
	lda	#12
	jsr	Shot_CB_Wait

	lda	SH_A,x
	sta	<FNC_WORK+3

	jsr	Shot_GetPlayerAngle
	sta	<FNC_WORK
	jsr	Rand
	and	#$07
	tay
	lda	.angle,y
	clc
	adc	<FNC_WORK
	sta	SH_A,x
	ldy	SH_D,x
	jsr	Shot_Normal_SetObjData

	lda	<FNC_WORK+3
	sec
	sbc	SH_A,x
	bpl	.1
	eor	#$ff
.1:
	tay
	lda	Xcn,y
	and	#$07
	asl	a
;	clc
	adc	#18
	sta	SH_SP,x
	ldy	SH_A,x
	jmp	Shot_SetVelocity
.angle:
	.db	$02,$01,$01,$00,$00,$ff,$ff,$fe

St5_ShCbAggFairyD:
	lda	SH_IS,x
	sta	SH_D,x
	lda	#$03
	sta	SH_VC,x
	sta	SH_VN,x
	lda	#$f7
	sta	SH_IS,x

	jsr	Rand
	and	#$0f
	tay
	lda	SH_A,x
	clc
	adc	.angle1,y
	sta	SH_A,x

	ldy	SH_D,x
	lda	.speed1,y
	sta	SH_SP,x

	ldy	SH_A,x
	jsr	Shot_SetVelocity

	; ҂
	lda	#6
	jsr	Shot_CB_Wait

	lda	#$00
	sta	SH_IS,x
	sta	SH_SP,x
	jsr	Shot_SetVelocity

	; ҂
	lda	#12
	jsr	Shot_CB_Wait

	jsr	Shot_GetPlayerAngle
	sta	<FNC_WORK
	jsr	Rand
	and	#$07
	tay
	lda	<FNC_WORK
	clc
	adc	.angle2,y
	sta	SH_A,x

	ldy	SH_D,x
	lda	.speed2,y
	sta	SH_SP,x

	ldy	SH_A,x
	jmp	Shot_SetVelocity
.angle1:
	.db	$0f, $0d, $0b, $09, $07, $05, $03, $01
	.db	$ff, $fd, $fb, $f9, $f7, $f5, $f3, $f1
.angle2:
	.db	$fe, $ff, $ff, $00, $00, $01, $01, $02
.speed1:
	.db	$14, $16, $18, $1a, $1c, $1e, $20, $22
.speed2:
	.db	$1f, $1c, $19, $16, $14, $12, $10, $0e

St5_ShCbLilyA:
	lda	#$00
	sta	SH_IS,x
	sta	SH_VC,x
	sta	SH_VN,x
	sta	SH_SP,x
	jsr	Shot_SetVelocity

	; ҂
	lda	#4
	jsr	Shot_CB_Wait

	ldy	SH_T,x
	lda	Xcn,y
	and	#$03
	bne	.1
	jsr	Shot_GetPlayerAngle
	ldy	#$00
	beq	.2	; same as jmp
.1:
	tay
	lda	.angle-1,y
	clc
	adc	SH_A,x
.2:
	sty	<FNC_WORK+2
	sta	SH_A,x
	ldy	SH_D,x
	jsr	Shot_Normal_SetObjData

	ldy	<FNC_WORK+2
	lda	.speed,y
	sta	SH_SP,x
	ldy	SH_A,x
	jmp	Shot_SetVelocity
.angle:
	.db	$80, $40, $c0
.speed:
	.db	18,8,20,20

St5_ShCbLilyB:
	jsr	Rand
	and	#$07
	tay
	lda	.disp,y
	clc
	adc	SH_A,x
	sta	SH_A,x

	jsr	Rand
	and	#$07
	tay
	lda	.disp,y
	clc
	adc	SH_SP,x
	sta	SH_SP,x
	ldy	SH_A,x
	jmp	Shot_SetVelocity
.disp:
	.db	$fe,$ff,$ff,$00,$00,$01,$01,$02

St5_ShCbLilyC:
	lda	#$00
	sta	SH_IA,x
	sta	SH_VC,x
	sta	SH_VN,x

	lda	SH_A,x
	clc
	adc	#$30
	cmp	#$60
	bcs	.2

	lda	SH_NUM
;	clc
	adc	SH_NUM+1
	cmp	#60
	bcs	.1

	lda	#20
	sta	SH_SP,x
	ldy	SH_A,x
	jmp	Shot_SetVelocity
.1:
;	sec
	ror	SH_X,x
.2:
	rts


St5_ShCbPrismA1:
.1:
	lda	#1
	jsr	Shot_CB_Wait

	lda	SH_SP,x
	beq	.2
	lda	SH_U,x
	clc
	adc	SH_DU,x
	lda	SH_X,x
	adc	SH_DX,x
	bmi	.2
	lda	SH_V,x
	clc
	adc	SH_DV,x
	lda	SH_Y,x
	adc	SH_DY,x
	cmp	#192
	bcc	.1
.2:
	lda	#$00
	sta	SH_IS,x
	sta	SH_VC,x
	sta	SH_VN,x

	lda	SH_A,x
	eor	#$80
	sta	SH_A,x
	tay
	lda	#16
	sta	SH_SP,x
	jsr	Shot_SetVelocity

.3;
	lda	#4
	jsr	Shot_CB_Wait

	lda	#LOW(BL(1,Blt5_PrismA2))
	ldy	#HIGH(BL(1,Blt5_PrismA2))
	jsr	SMCL(Shot_Normal_Create)

	jmp	.3

St5_ShCbPrismA2:
	lda	SH_A,x
	sta	SH_D,x

	jsr	Rand
	and	#$7f
	clc
	adc	SH_A,x
	sta	SH_A,x
	tay
	lda	SH_SP,x
	jsr	Shot_SetVelocity

	lda	#8
	jsr	Shot_CB_Wait

	lda	#$00
	sta	SH_IS,x
	sta	SH_VC,x
	sta	SH_VN,x

	lda	#40
	jsr	Shot_CB_Wait

	lda	SH_NUM
	clc
	adc	SH_NUM+1
	cmp	#60
	bcs	.1

	jsr	Rand
	and	#$3f
	clc
	adc	#$20
;	clc
	adc	SH_D,x
	sta	SH_A,x
	tay
	lda	#8
	sta	SH_SP,x
	jmp	Shot_SetVelocity
.1:
;	sec
	ror	SH_X,x
	rts

St5_ShCbPrismB:
	lda	SH_IA,x
	cmp	#$80
	ror	a
	sta	SH_IA,x
	lda	#1
	sta	SH_IS,x

	lda	#16
	jsr	Shot_CB_Wait

	lda	#$00
	sta	SH_IS,x

	lda	SH_IA,x
	cmp	#$80
	ror	a
	sta	SH_IA,x

	jsr	Shot_GetPlayerAngle
	sta	SH_A,x
	tay
	lda	SH_SP,x
	jsr	Shot_SetVelocity

	lda	#LOW(BL(1,Blt5_PrismC))
	ldy	#HIGH(BL(1,Blt5_PrismC))
	jsr	SMCL(Shot_Normal_Create)

.1:
	lda	#4
	jsr	Shot_CB_Wait

	lda	#0
	sec
	sbc	SH_IA,x
	sta	SH_IA,x

	lda	#4
	jsr	Shot_CB_Wait

	inc	SH_SP,x

	lda	SH_IA,x
	bmi	.1
	asl	a
	sta	SH_IA,x
	bcc	.1	; same as jmp

St5_ShCbPrismE1:
	lda	#$00
	sta	SH_IS,x
	sta	SH_SP,x
	jsr	Shot_SetVelocity

	; ҂
	lda	#4
	jsr	Shot_CB_Wait

	ldy	SH_T,x
	lda	Xcn,y
	lsr	a
	sta	<FNC_WORK+8

	bcc	.1

	lda	#LOW(BL(1,Blt5_PrismE2))
	ldy	#HIGH(BL(1,Blt5_PrismE2))
	jsr	SMCL(Shot_Normal_Create)
.1:
	lsr	<FNC_WORK+8
	bcc	.2

	lda	#LOW(BL(1,Blt5_PrismE3))
	ldy	#HIGH(BL(1,Blt5_PrismE3))
	jsr	SMCL(Shot_Normal_Create)
.2:
	sec
	ror	SH_X,x
	rts

St5_ShCbPrismE2:
	; SH_IS: $fd->12 $fc->13 $fb->15 $fa->17
	lda	SH_IS,x
	eor	#$ff
	tay
	lda	.sp-2,y
	sta	SH_SP,x

	lda	#$00
	sta	SH_IS,x
	jsr	Shot_SetVelocity

	; ҂
	lda	#12
	jsr	Shot_CB_Wait

	lda	SH_SP,x
	ldy	SH_A,x
	jmp	Shot_SetVelocity
.sp:
	.db	12,13,15,17

St5_ShCbPrismG:
	ldy	SH_IA,x
	lda	.blt_hi,y
	sta	<FNC_WORK
	lda	.blt_lo,y
	ldy	<FNC_WORK
	jsr	SMCL(Shot_Normal_Create)

	sec
	ror	SH_X,x
	rts
.blt_lo:
	.db	LOW(BL(1,Blt5_PrismG5))
	.db	LOW(BL(1,Blt5_PrismG6))
	.db	LOW(BL(1,Blt5_PrismG7))
	.db	LOW(BL(1,Blt5_PrismG8))
.blt_hi:
	.db	HIGH(BL(1,Blt5_PrismG5))
	.db	HIGH(BL(1,Blt5_PrismG6))
	.db	HIGH(BL(1,Blt5_PrismG7))
	.db	HIGH(BL(1,Blt5_PrismG8))

St5_ShCbPrismH:
	lda	#$02
	sta	SH_T,x

	lda	#23
	sta	SH_SP,x

	jsr	Shot_GetPlayerAngle
	sta	SH_A,x

	ldy	SH_D,x
	jsr	Shot_Normal_SetObjData

	lda	SH_SP,x
	ldy	SH_A,x
	jmp	Shot_SetVelocity

St5_ShCbPrismI:
.1:
	; ҂
	lda	#2
	jsr	Shot_CB_Wait

	lda	<EN_ST5_FADE
	cmp	#$12
	bcs	.1

	; [U[蔻
	lda	SH_Y,x
	lsr	a
	lsr	a
	lsr	a
	tay
	lda	BGS_LAYER_L,y
	sta	<FNC_WORK
	lda	BGS_LAYER_H,y
	sta	<FNC_WORK+1
	lda	SH_X,x
	lsr	a
	lsr	a
	lsr	a
	tay
	lda	[FNC_WORK],y
	beq	.1

	jsr	Rand
	and	#$03
	tay
	lda	SH_SP,x
	clc
	adc	.sp,y
	sta	SH_SP,x

	jsr	Shot_GetPlayerAngle
	sec
	sbc	SH_A,x
	cmp	#$80
	ror	a
	cmp	#$80
	ror	a
	adc	SH_A,x
	sta	SH_A,x

	ldy	SH_D,x
	jsr	Shot_Normal_SetObjData

	lda	SH_SP,x
	ldy	SH_A,x
	jsr	Shot_SetVelocity

	; ҂
	lda	#3
	jsr	Shot_CB_Wait

	jmp	.1
.sp:
	.db	$02,$00,$00,$fe

St5_ShCbPrismK:
	jsr	Shot_GetPlayerAngle
	sec
	sbc	SH_A,x
	clc
	adc	#$30
	cmp	#$60
	bcc	.1
	lda	SH_A,x
	lsr	a
	bcc	.1
	ror	SH_X,x
	rts
.1:
	; ҂
	lda	#2
	jsr	Shot_CB_Wait

	; [U[蔻
	lda	SH_Y,x
	lsr	a
	lsr	a
	lsr	a
	tay
	lda	BGS_LAYER_L,y
	sta	<FNC_WORK
	lda	BGS_LAYER_H,y
	sta	<FNC_WORK+1
	lda	SH_X,x
	lsr	a
	lsr	a
	lsr	a
	tay
	lda	[FNC_WORK],y
	beq	.1

	lda	<EN_ST5_INVPAL
	beq	.2
	rts
.2:
	jsr	Shot_GetPlayerAngle
	tay
	sec
	sbc	SH_A,x
	clc
	adc	#$58
	cmp	#$b0
	bcc	.3
	lda	#21
	sta	SH_SP,x
	lda	#15
	bne	.4	; same as jmp
.3:
	ldy	SH_A,x
	lda	#7
.4:
	sta	<FNC_WORK
	jsr	Rand
	and	<FNC_WORK
	eor	Int,y
	sta	SH_A,x

	ldy	SH_D,x
	jsr	Shot_Normal_SetObjData

	lda	SH_SP,x
	ldy	SH_A,x
	jmp	Shot_SetVelocity

; g[NV[PT֌W

St5_TalkFunc:
	tay
	lda	.lo,y
	ldx	.hi,y
	jsr	SMCL(Vcmd_SequenceData2)
	beq	.1
	ldy	#0
	rts
.1:
	ldy	#2
	rts
.lo:
	.db	LOW(Vcmd_Prismriver)
	.db	LOW(Vcmd_PrismriverClear)
.hi:
	.db	HIGH(Vcmd_Prismriver)
	.db	HIGH(Vcmd_PrismriverClear)

St5_Prismriver_DataX:
	.db	VCX(0,3), $88, $aa, $ff
St5_Prismriver_DataX_End:
St5_Prismriver_DataY:
	.db	VCX(0,1), $00, VCX(1,2)
St5_Prismriver_DataY_End:
St5_Prismriver_Data1:
	.db	VCX(0,9), BG_ST5_FIGURE,   BG_ST5_FIGURE+1,  BG_ST5_FIGURE+2
	.db	          BG_ST5_FIGURE+3, BG_ST5_FIGURE+4, BG_ST5_FIGURE+5
	.db	          BG_ST5_FIGURE+6, BG_ST5_FIGURE+7, BG_ST5_FIGURE+8
St5_Prismriver_Data1_End:
St5_Prismriver_Data2:
	.db	VCX(0,9), BG_ST5_FIGURE+9,  BG_ST5_FIGURE+10, BG_ST5_FIGURE+11
	.db	          BG_ST5_FIGURE+12, BG_ST5_FIGURE+13, BG_ST5_FIGURE+14
	.db	          BG_ST5_FIGURE+15, BG_ST5_FIGURE+16, BG_ST5_FIGURE+17
St5_Prismriver_Data2_End:
St5_Prismriver_Data3:
	.db	VCX(0,9), BG_ST5_FIGURE+18, BG_ST5_FIGURE+19, BG_ST5_FIGURE+20
	.db	          BG_ST5_FIGURE+21, BG_ST5_FIGURE+22, BG_ST5_FIGURE+23
	.db	          BG_ST5_FIGURE+24, BG_ST5_FIGURE+25, BG_ST5_FIGURE+26
St5_Prismriver_Data3_End:
St5_Prismriver_Data4:
	.db	VCX(0,9), BG_ST5_FIGURE+27, BG_ST5_FIGURE+28, BG_ST5_FIGURE+29
	.db	          BG_ST5_FIGURE+30, BG_ST5_FIGURE+31, BG_ST5_FIGURE+32
	.db	          BG_ST5_FIGURE+33, BG_ST5_FIGURE+34, BG_ST5_FIGURE+35
St5_Prismriver_Data4_End:
St5_Prismriver_Data5:
	.db	VCX(0,9), BG_ST5_FIGURE+36, BG_ST5_FIGURE+37, BG_ST5_FIGURE+38
	.db	          BG_ST5_FIGURE+39, BG_ST5_FIGURE+40, BG_ST5_FIGURE+41
	.db	          BG_ST5_FIGURE+42, BG_ST5_FIGURE+43, BG_ST5_FIGURE+44
St5_Prismriver_Data5_End:
St5_Prismriver_Data6:
	.db	VCX(0,9), BG_ST5_FIGURE+45, BG_ST5_FIGURE+46, BG_ST5_FIGURE+47
	.db	          BG_ST5_FIGURE+48, BG_ST5_FIGURE+49, BG_ST5_FIGURE+50
	.db	          BG_ST5_FIGURE+51, BG_ST5_FIGURE+52, BG_ST5_FIGURE+53
St5_Prismriver_Data6_End:
St5_Prismriver_Data7:
	.db	VCX(0,1), BG_TILE, VCX(1,8)
St5_Prismriver_Data7_End:

Vcmd_Prismriver:
	VCMD_SET	$00, $2bf4, St5_Prismriver_DataX, St5_Prismriver_DataX_End
	VCMD_SET	$00, $23fc, St5_Prismriver_DataX, St5_Prismriver_DataX_End
	VCMD_SET	$00, $2b13, St5_Prismriver_Data1, St5_Prismriver_Data1_End
	VCMD_SET	$00, $2b33, St5_Prismriver_Data2, St5_Prismriver_Data2_End
	VCMD_SET	$00, $2b53, St5_Prismriver_Data3, St5_Prismriver_Data3_End
	VCMD_SET	$00, $2b73, St5_Prismriver_Data4, St5_Prismriver_Data4_End
	VCMD_SET	$00, $2393, St5_Prismriver_Data5, St5_Prismriver_Data5_End
	VCMD_SET	$80, $23b3, St5_Prismriver_Data6, St5_Prismriver_Data6_End

Vcmd_PrismriverClear:
	VCMD_SET	$00, $2bf4, St5_Prismriver_DataY, St5_Prismriver_DataY_End
	VCMD_SET	$00, $23fc, St5_Prismriver_DataY, St5_Prismriver_DataY_End
	VCMD_SET	$00, $2b13, St5_Prismriver_Data7, St5_Prismriver_Data7_End
	VCMD_SET	$00, $2b33, St5_Prismriver_Data7, St5_Prismriver_Data7_End
	VCMD_SET	$00, $2b53, St5_Prismriver_Data7, St5_Prismriver_Data7_End
	VCMD_SET	$00, $2b73, St5_Prismriver_Data7, St5_Prismriver_Data7_End
	VCMD_SET	$00, $2393, St5_Prismriver_Data7, St5_Prismriver_Data7_End
	VCMD_SET	$80, $23b3, St5_Prismriver_Data7, St5_Prismriver_Data7_End

